// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/AllSystemStatuses.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__ALL_SYSTEM_STATUSES__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__ALL_SYSTEM_STATUSES__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'enabled_status'
// Member 'overridden_status'
// Member 'fault_status'
#include "pacmod_msgs/msg/detail/key_value_pair__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__AllSystemStatuses __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__AllSystemStatuses __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AllSystemStatuses_
{
  using Type = AllSystemStatuses_<ContainerAllocator>;

  explicit AllSystemStatuses_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit AllSystemStatuses_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _enabled_status_type =
    std::vector<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>, typename ContainerAllocator::template rebind<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>>::other>;
  _enabled_status_type enabled_status;
  using _overridden_status_type =
    std::vector<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>, typename ContainerAllocator::template rebind<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>>::other>;
  _overridden_status_type overridden_status;
  using _fault_status_type =
    std::vector<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>, typename ContainerAllocator::template rebind<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>>::other>;
  _fault_status_type fault_status;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__enabled_status(
    const std::vector<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>, typename ContainerAllocator::template rebind<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>>::other> & _arg)
  {
    this->enabled_status = _arg;
    return *this;
  }
  Type & set__overridden_status(
    const std::vector<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>, typename ContainerAllocator::template rebind<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>>::other> & _arg)
  {
    this->overridden_status = _arg;
    return *this;
  }
  Type & set__fault_status(
    const std::vector<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>, typename ContainerAllocator::template rebind<pacmod_msgs::msg::KeyValuePair_<ContainerAllocator>>::other> & _arg)
  {
    this->fault_status = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__AllSystemStatuses
    std::shared_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__AllSystemStatuses
    std::shared_ptr<pacmod_msgs::msg::AllSystemStatuses_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AllSystemStatuses_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->enabled_status != other.enabled_status) {
      return false;
    }
    if (this->overridden_status != other.overridden_status) {
      return false;
    }
    if (this->fault_status != other.fault_status) {
      return false;
    }
    return true;
  }
  bool operator!=(const AllSystemStatuses_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AllSystemStatuses_

// alias to use template instance with default allocator
using AllSystemStatuses =
  pacmod_msgs::msg::AllSystemStatuses_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__ALL_SYSTEM_STATUSES__STRUCT_HPP_
