// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/BrakeAuxRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/brake_aux_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__BrakeAuxRpt__init(pacmod_msgs__msg__BrakeAuxRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__BrakeAuxRpt__fini(msg);
    return false;
  }
  // raw_pedal_pos
  // raw_pedal_pos_is_valid
  // raw_pedal_force
  // raw_pedal_force_is_valid
  // raw_brake_pressure
  // raw_brake_pressure_is_valid
  // brake_on_off
  // brake_on_off_is_valid
  // user_interaction
  // user_interaction_is_valid
  return true;
}

void
pacmod_msgs__msg__BrakeAuxRpt__fini(pacmod_msgs__msg__BrakeAuxRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // raw_pedal_pos
  // raw_pedal_pos_is_valid
  // raw_pedal_force
  // raw_pedal_force_is_valid
  // raw_brake_pressure
  // raw_brake_pressure_is_valid
  // brake_on_off
  // brake_on_off_is_valid
  // user_interaction
  // user_interaction_is_valid
}

pacmod_msgs__msg__BrakeAuxRpt *
pacmod_msgs__msg__BrakeAuxRpt__create()
{
  pacmod_msgs__msg__BrakeAuxRpt * msg = (pacmod_msgs__msg__BrakeAuxRpt *)malloc(sizeof(pacmod_msgs__msg__BrakeAuxRpt));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__BrakeAuxRpt));
  bool success = pacmod_msgs__msg__BrakeAuxRpt__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__BrakeAuxRpt__destroy(pacmod_msgs__msg__BrakeAuxRpt * msg)
{
  if (msg) {
    pacmod_msgs__msg__BrakeAuxRpt__fini(msg);
  }
  free(msg);
}


bool
pacmod_msgs__msg__BrakeAuxRpt__Sequence__init(pacmod_msgs__msg__BrakeAuxRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  pacmod_msgs__msg__BrakeAuxRpt * data = NULL;
  if (size) {
    data = (pacmod_msgs__msg__BrakeAuxRpt *)calloc(size, sizeof(pacmod_msgs__msg__BrakeAuxRpt));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__BrakeAuxRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__BrakeAuxRpt__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__BrakeAuxRpt__Sequence__fini(pacmod_msgs__msg__BrakeAuxRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__BrakeAuxRpt__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__BrakeAuxRpt__Sequence *
pacmod_msgs__msg__BrakeAuxRpt__Sequence__create(size_t size)
{
  pacmod_msgs__msg__BrakeAuxRpt__Sequence * array = (pacmod_msgs__msg__BrakeAuxRpt__Sequence *)malloc(sizeof(pacmod_msgs__msg__BrakeAuxRpt__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__BrakeAuxRpt__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__BrakeAuxRpt__Sequence__destroy(pacmod_msgs__msg__BrakeAuxRpt__Sequence * array)
{
  if (array) {
    pacmod_msgs__msg__BrakeAuxRpt__Sequence__fini(array);
  }
  free(array);
}
