// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/ComponentRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__COMPONENT_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__COMPONENT_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__ComponentRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__ComponentRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ComponentRpt_
{
  using Type = ComponentRpt_<ContainerAllocator>;

  explicit ComponentRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->component_type = 0;
      this->component_func = 0;
      this->counter = 0;
      this->complement = 0;
      this->config_fault = false;
    }
  }

  explicit ComponentRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->component_type = 0;
      this->component_func = 0;
      this->counter = 0;
      this->complement = 0;
      this->config_fault = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _component_type_type =
    uint8_t;
  _component_type_type component_type;
  using _component_func_type =
    uint8_t;
  _component_func_type component_func;
  using _counter_type =
    uint8_t;
  _counter_type counter;
  using _complement_type =
    uint8_t;
  _complement_type complement;
  using _config_fault_type =
    bool;
  _config_fault_type config_fault;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__component_type(
    const uint8_t & _arg)
  {
    this->component_type = _arg;
    return *this;
  }
  Type & set__component_func(
    const uint8_t & _arg)
  {
    this->component_func = _arg;
    return *this;
  }
  Type & set__counter(
    const uint8_t & _arg)
  {
    this->counter = _arg;
    return *this;
  }
  Type & set__complement(
    const uint8_t & _arg)
  {
    this->complement = _arg;
    return *this;
  }
  Type & set__config_fault(
    const bool & _arg)
  {
    this->config_fault = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t COMPONENT_TYPE_PACMOD =
    0u;
  static constexpr uint8_t COMPONENT_TYPE_PACMINI =
    1u;
  static constexpr uint8_t COMPONENT_TYPE_PACMICRO =
    2u;
  static constexpr uint8_t COMPONENT_FUNC_PACMOD =
    0u;
  static constexpr uint8_t COMPONENT_FUNC_STEERING_AND_STEERING_COLUMN =
    1u;
  static constexpr uint8_t COMPONENT_FUNC_ACCELERATOR_AND_BRAKING =
    2u;
  static constexpr uint8_t COMPONENT_FUNC_BRAKING =
    3u;
  static constexpr uint8_t COMPONENT_FUNC_SHIFTING =
    4u;
  static constexpr uint8_t COMPONENT_FUNC_STEERING =
    5u;
  static constexpr uint8_t COMPONENT_FUNC_E_SHIFTER =
    6u;
  static constexpr uint8_t COMPONENT_FUNC_WATCHDOG =
    7u;

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::ComponentRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::ComponentRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::ComponentRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::ComponentRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__ComponentRpt
    std::shared_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__ComponentRpt
    std::shared_ptr<pacmod_msgs::msg::ComponentRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ComponentRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->component_type != other.component_type) {
      return false;
    }
    if (this->component_func != other.component_func) {
      return false;
    }
    if (this->counter != other.counter) {
      return false;
    }
    if (this->complement != other.complement) {
      return false;
    }
    if (this->config_fault != other.config_fault) {
      return false;
    }
    return true;
  }
  bool operator!=(const ComponentRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ComponentRpt_

// alias to use template instance with default allocator
using ComponentRpt =
  pacmod_msgs::msg::ComponentRpt_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_TYPE_PACMOD;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_TYPE_PACMINI;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_TYPE_PACMICRO;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_PACMOD;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_STEERING_AND_STEERING_COLUMN;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_ACCELERATOR_AND_BRAKING;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_BRAKING;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_SHIFTING;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_STEERING;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_E_SHIFTER;
template<typename ContainerAllocator>
constexpr uint8_t ComponentRpt_<ContainerAllocator>::COMPONENT_FUNC_WATCHDOG;

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__COMPONENT_RPT__STRUCT_HPP_
