// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/DetectedObjectRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__DETECTED_OBJECT_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__DETECTED_OBJECT_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__DetectedObjectRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__DetectedObjectRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DetectedObjectRpt_
{
  using Type = DetectedObjectRpt_<ContainerAllocator>;

  explicit DetectedObjectRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_object_distance_low_res = 0.0;
      this->front_object_distance_high_res = 0.0;
    }
  }

  explicit DetectedObjectRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_object_distance_low_res = 0.0;
      this->front_object_distance_high_res = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _front_object_distance_low_res_type =
    double;
  _front_object_distance_low_res_type front_object_distance_low_res;
  using _front_object_distance_high_res_type =
    double;
  _front_object_distance_high_res_type front_object_distance_high_res;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__front_object_distance_low_res(
    const double & _arg)
  {
    this->front_object_distance_low_res = _arg;
    return *this;
  }
  Type & set__front_object_distance_high_res(
    const double & _arg)
  {
    this->front_object_distance_high_res = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__DetectedObjectRpt
    std::shared_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__DetectedObjectRpt
    std::shared_ptr<pacmod_msgs::msg::DetectedObjectRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectedObjectRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->front_object_distance_low_res != other.front_object_distance_low_res) {
      return false;
    }
    if (this->front_object_distance_high_res != other.front_object_distance_high_res) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectedObjectRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectedObjectRpt_

// alias to use template instance with default allocator
using DetectedObjectRpt =
  pacmod_msgs::msg::DetectedObjectRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__DETECTED_OBJECT_RPT__STRUCT_HPP_
