// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/DoorRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__DOOR_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__DOOR_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__DoorRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__DoorRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DoorRpt_
{
  using Type = DoorRpt_<ContainerAllocator>;

  explicit DoorRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->driver_door_open = false;
      this->driver_door_open_is_valid = false;
      this->passenger_door_open = false;
      this->passenger_door_open_is_valid = false;
      this->rear_driver_door_open = false;
      this->rear_driver_door_open_is_valid = false;
      this->rear_passenger_door_open = false;
      this->rear_passenger_door_open_is_valid = false;
      this->hood_open = false;
      this->hood_open_is_valid = false;
      this->trunk_open = false;
      this->trunk_open_is_valid = false;
      this->fuel_door_open = false;
      this->fuel_door_open_is_valid = false;
    }
  }

  explicit DoorRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->driver_door_open = false;
      this->driver_door_open_is_valid = false;
      this->passenger_door_open = false;
      this->passenger_door_open_is_valid = false;
      this->rear_driver_door_open = false;
      this->rear_driver_door_open_is_valid = false;
      this->rear_passenger_door_open = false;
      this->rear_passenger_door_open_is_valid = false;
      this->hood_open = false;
      this->hood_open_is_valid = false;
      this->trunk_open = false;
      this->trunk_open_is_valid = false;
      this->fuel_door_open = false;
      this->fuel_door_open_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _driver_door_open_type =
    bool;
  _driver_door_open_type driver_door_open;
  using _driver_door_open_is_valid_type =
    bool;
  _driver_door_open_is_valid_type driver_door_open_is_valid;
  using _passenger_door_open_type =
    bool;
  _passenger_door_open_type passenger_door_open;
  using _passenger_door_open_is_valid_type =
    bool;
  _passenger_door_open_is_valid_type passenger_door_open_is_valid;
  using _rear_driver_door_open_type =
    bool;
  _rear_driver_door_open_type rear_driver_door_open;
  using _rear_driver_door_open_is_valid_type =
    bool;
  _rear_driver_door_open_is_valid_type rear_driver_door_open_is_valid;
  using _rear_passenger_door_open_type =
    bool;
  _rear_passenger_door_open_type rear_passenger_door_open;
  using _rear_passenger_door_open_is_valid_type =
    bool;
  _rear_passenger_door_open_is_valid_type rear_passenger_door_open_is_valid;
  using _hood_open_type =
    bool;
  _hood_open_type hood_open;
  using _hood_open_is_valid_type =
    bool;
  _hood_open_is_valid_type hood_open_is_valid;
  using _trunk_open_type =
    bool;
  _trunk_open_type trunk_open;
  using _trunk_open_is_valid_type =
    bool;
  _trunk_open_is_valid_type trunk_open_is_valid;
  using _fuel_door_open_type =
    bool;
  _fuel_door_open_type fuel_door_open;
  using _fuel_door_open_is_valid_type =
    bool;
  _fuel_door_open_is_valid_type fuel_door_open_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__driver_door_open(
    const bool & _arg)
  {
    this->driver_door_open = _arg;
    return *this;
  }
  Type & set__driver_door_open_is_valid(
    const bool & _arg)
  {
    this->driver_door_open_is_valid = _arg;
    return *this;
  }
  Type & set__passenger_door_open(
    const bool & _arg)
  {
    this->passenger_door_open = _arg;
    return *this;
  }
  Type & set__passenger_door_open_is_valid(
    const bool & _arg)
  {
    this->passenger_door_open_is_valid = _arg;
    return *this;
  }
  Type & set__rear_driver_door_open(
    const bool & _arg)
  {
    this->rear_driver_door_open = _arg;
    return *this;
  }
  Type & set__rear_driver_door_open_is_valid(
    const bool & _arg)
  {
    this->rear_driver_door_open_is_valid = _arg;
    return *this;
  }
  Type & set__rear_passenger_door_open(
    const bool & _arg)
  {
    this->rear_passenger_door_open = _arg;
    return *this;
  }
  Type & set__rear_passenger_door_open_is_valid(
    const bool & _arg)
  {
    this->rear_passenger_door_open_is_valid = _arg;
    return *this;
  }
  Type & set__hood_open(
    const bool & _arg)
  {
    this->hood_open = _arg;
    return *this;
  }
  Type & set__hood_open_is_valid(
    const bool & _arg)
  {
    this->hood_open_is_valid = _arg;
    return *this;
  }
  Type & set__trunk_open(
    const bool & _arg)
  {
    this->trunk_open = _arg;
    return *this;
  }
  Type & set__trunk_open_is_valid(
    const bool & _arg)
  {
    this->trunk_open_is_valid = _arg;
    return *this;
  }
  Type & set__fuel_door_open(
    const bool & _arg)
  {
    this->fuel_door_open = _arg;
    return *this;
  }
  Type & set__fuel_door_open_is_valid(
    const bool & _arg)
  {
    this->fuel_door_open_is_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::DoorRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::DoorRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::DoorRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::DoorRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__DoorRpt
    std::shared_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__DoorRpt
    std::shared_ptr<pacmod_msgs::msg::DoorRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DoorRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->driver_door_open != other.driver_door_open) {
      return false;
    }
    if (this->driver_door_open_is_valid != other.driver_door_open_is_valid) {
      return false;
    }
    if (this->passenger_door_open != other.passenger_door_open) {
      return false;
    }
    if (this->passenger_door_open_is_valid != other.passenger_door_open_is_valid) {
      return false;
    }
    if (this->rear_driver_door_open != other.rear_driver_door_open) {
      return false;
    }
    if (this->rear_driver_door_open_is_valid != other.rear_driver_door_open_is_valid) {
      return false;
    }
    if (this->rear_passenger_door_open != other.rear_passenger_door_open) {
      return false;
    }
    if (this->rear_passenger_door_open_is_valid != other.rear_passenger_door_open_is_valid) {
      return false;
    }
    if (this->hood_open != other.hood_open) {
      return false;
    }
    if (this->hood_open_is_valid != other.hood_open_is_valid) {
      return false;
    }
    if (this->trunk_open != other.trunk_open) {
      return false;
    }
    if (this->trunk_open_is_valid != other.trunk_open_is_valid) {
      return false;
    }
    if (this->fuel_door_open != other.fuel_door_open) {
      return false;
    }
    if (this->fuel_door_open_is_valid != other.fuel_door_open_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const DoorRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DoorRpt_

// alias to use template instance with default allocator
using DoorRpt =
  pacmod_msgs::msg::DoorRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__DOOR_RPT__STRUCT_HPP_
