// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/EngineRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__ENGINE_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__ENGINE_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__EngineRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__EngineRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EngineRpt_
{
  using Type = EngineRpt_<ContainerAllocator>;

  explicit EngineRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->engine_speed = 0.0;
      this->engine_torque = 0.0;
      this->engine_coolant_temp = 0;
      this->engine_speed_avail = false;
      this->engine_torque_avail = false;
      this->engine_coolant_temp_avail = false;
    }
  }

  explicit EngineRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->engine_speed = 0.0;
      this->engine_torque = 0.0;
      this->engine_coolant_temp = 0;
      this->engine_speed_avail = false;
      this->engine_torque_avail = false;
      this->engine_coolant_temp_avail = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _engine_speed_type =
    double;
  _engine_speed_type engine_speed;
  using _engine_torque_type =
    double;
  _engine_torque_type engine_torque;
  using _engine_coolant_temp_type =
    int16_t;
  _engine_coolant_temp_type engine_coolant_temp;
  using _engine_speed_avail_type =
    bool;
  _engine_speed_avail_type engine_speed_avail;
  using _engine_torque_avail_type =
    bool;
  _engine_torque_avail_type engine_torque_avail;
  using _engine_coolant_temp_avail_type =
    bool;
  _engine_coolant_temp_avail_type engine_coolant_temp_avail;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__engine_speed(
    const double & _arg)
  {
    this->engine_speed = _arg;
    return *this;
  }
  Type & set__engine_torque(
    const double & _arg)
  {
    this->engine_torque = _arg;
    return *this;
  }
  Type & set__engine_coolant_temp(
    const int16_t & _arg)
  {
    this->engine_coolant_temp = _arg;
    return *this;
  }
  Type & set__engine_speed_avail(
    const bool & _arg)
  {
    this->engine_speed_avail = _arg;
    return *this;
  }
  Type & set__engine_torque_avail(
    const bool & _arg)
  {
    this->engine_torque_avail = _arg;
    return *this;
  }
  Type & set__engine_coolant_temp_avail(
    const bool & _arg)
  {
    this->engine_coolant_temp_avail = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::EngineRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::EngineRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::EngineRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::EngineRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__EngineRpt
    std::shared_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__EngineRpt
    std::shared_ptr<pacmod_msgs::msg::EngineRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EngineRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->engine_speed != other.engine_speed) {
      return false;
    }
    if (this->engine_torque != other.engine_torque) {
      return false;
    }
    if (this->engine_coolant_temp != other.engine_coolant_temp) {
      return false;
    }
    if (this->engine_speed_avail != other.engine_speed_avail) {
      return false;
    }
    if (this->engine_torque_avail != other.engine_torque_avail) {
      return false;
    }
    if (this->engine_coolant_temp_avail != other.engine_coolant_temp_avail) {
      return false;
    }
    return true;
  }
  bool operator!=(const EngineRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EngineRpt_

// alias to use template instance with default allocator
using EngineRpt =
  pacmod_msgs::msg::EngineRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__ENGINE_RPT__STRUCT_HPP_
