// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/LatLonHeadingRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__LAT_LON_HEADING_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__LAT_LON_HEADING_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__LatLonHeadingRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__LatLonHeadingRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LatLonHeadingRpt_
{
  using Type = LatLonHeadingRpt_<ContainerAllocator>;

  explicit LatLonHeadingRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->latitude_degrees = 0;
      this->latitude_minutes = 0;
      this->latitude_seconds = 0;
      this->longitude_degrees = 0;
      this->longitude_minutes = 0;
      this->longitude_seconds = 0;
      this->heading = 0.0;
    }
  }

  explicit LatLonHeadingRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->latitude_degrees = 0;
      this->latitude_minutes = 0;
      this->latitude_seconds = 0;
      this->longitude_degrees = 0;
      this->longitude_minutes = 0;
      this->longitude_seconds = 0;
      this->heading = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _latitude_degrees_type =
    int8_t;
  _latitude_degrees_type latitude_degrees;
  using _latitude_minutes_type =
    uint8_t;
  _latitude_minutes_type latitude_minutes;
  using _latitude_seconds_type =
    uint8_t;
  _latitude_seconds_type latitude_seconds;
  using _longitude_degrees_type =
    int8_t;
  _longitude_degrees_type longitude_degrees;
  using _longitude_minutes_type =
    uint8_t;
  _longitude_minutes_type longitude_minutes;
  using _longitude_seconds_type =
    uint8_t;
  _longitude_seconds_type longitude_seconds;
  using _heading_type =
    double;
  _heading_type heading;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__latitude_degrees(
    const int8_t & _arg)
  {
    this->latitude_degrees = _arg;
    return *this;
  }
  Type & set__latitude_minutes(
    const uint8_t & _arg)
  {
    this->latitude_minutes = _arg;
    return *this;
  }
  Type & set__latitude_seconds(
    const uint8_t & _arg)
  {
    this->latitude_seconds = _arg;
    return *this;
  }
  Type & set__longitude_degrees(
    const int8_t & _arg)
  {
    this->longitude_degrees = _arg;
    return *this;
  }
  Type & set__longitude_minutes(
    const uint8_t & _arg)
  {
    this->longitude_minutes = _arg;
    return *this;
  }
  Type & set__longitude_seconds(
    const uint8_t & _arg)
  {
    this->longitude_seconds = _arg;
    return *this;
  }
  Type & set__heading(
    const double & _arg)
  {
    this->heading = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__LatLonHeadingRpt
    std::shared_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__LatLonHeadingRpt
    std::shared_ptr<pacmod_msgs::msg::LatLonHeadingRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LatLonHeadingRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->latitude_degrees != other.latitude_degrees) {
      return false;
    }
    if (this->latitude_minutes != other.latitude_minutes) {
      return false;
    }
    if (this->latitude_seconds != other.latitude_seconds) {
      return false;
    }
    if (this->longitude_degrees != other.longitude_degrees) {
      return false;
    }
    if (this->longitude_minutes != other.longitude_minutes) {
      return false;
    }
    if (this->longitude_seconds != other.longitude_seconds) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    return true;
  }
  bool operator!=(const LatLonHeadingRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LatLonHeadingRpt_

// alias to use template instance with default allocator
using LatLonHeadingRpt =
  pacmod_msgs::msg::LatLonHeadingRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__LAT_LON_HEADING_RPT__STRUCT_HPP_
