// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/OccupancyRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__OCCUPANCY_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__OCCUPANCY_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__OccupancyRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__OccupancyRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct OccupancyRpt_
{
  using Type = OccupancyRpt_<ContainerAllocator>;

  explicit OccupancyRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->driver_seat_occupied = false;
      this->driver_seat_occupied_is_valid = false;
      this->passenger_seat_occupied = false;
      this->passenger_seat_occupied_is_valid = false;
      this->rear_seat_occupied = false;
      this->rear_seat_occupied_is_valid = false;
      this->driver_seatbelt_buckled = false;
      this->driver_seatbelt_buckled_is_valid = false;
      this->passenger_seatbelt_buckled = false;
      this->passenger_seatbelt_buckled_is_valid = false;
      this->rear_seatbelt_buckled = false;
      this->rear_seatbelt_buckled_is_valid = false;
    }
  }

  explicit OccupancyRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->driver_seat_occupied = false;
      this->driver_seat_occupied_is_valid = false;
      this->passenger_seat_occupied = false;
      this->passenger_seat_occupied_is_valid = false;
      this->rear_seat_occupied = false;
      this->rear_seat_occupied_is_valid = false;
      this->driver_seatbelt_buckled = false;
      this->driver_seatbelt_buckled_is_valid = false;
      this->passenger_seatbelt_buckled = false;
      this->passenger_seatbelt_buckled_is_valid = false;
      this->rear_seatbelt_buckled = false;
      this->rear_seatbelt_buckled_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _driver_seat_occupied_type =
    bool;
  _driver_seat_occupied_type driver_seat_occupied;
  using _driver_seat_occupied_is_valid_type =
    bool;
  _driver_seat_occupied_is_valid_type driver_seat_occupied_is_valid;
  using _passenger_seat_occupied_type =
    bool;
  _passenger_seat_occupied_type passenger_seat_occupied;
  using _passenger_seat_occupied_is_valid_type =
    bool;
  _passenger_seat_occupied_is_valid_type passenger_seat_occupied_is_valid;
  using _rear_seat_occupied_type =
    bool;
  _rear_seat_occupied_type rear_seat_occupied;
  using _rear_seat_occupied_is_valid_type =
    bool;
  _rear_seat_occupied_is_valid_type rear_seat_occupied_is_valid;
  using _driver_seatbelt_buckled_type =
    bool;
  _driver_seatbelt_buckled_type driver_seatbelt_buckled;
  using _driver_seatbelt_buckled_is_valid_type =
    bool;
  _driver_seatbelt_buckled_is_valid_type driver_seatbelt_buckled_is_valid;
  using _passenger_seatbelt_buckled_type =
    bool;
  _passenger_seatbelt_buckled_type passenger_seatbelt_buckled;
  using _passenger_seatbelt_buckled_is_valid_type =
    bool;
  _passenger_seatbelt_buckled_is_valid_type passenger_seatbelt_buckled_is_valid;
  using _rear_seatbelt_buckled_type =
    bool;
  _rear_seatbelt_buckled_type rear_seatbelt_buckled;
  using _rear_seatbelt_buckled_is_valid_type =
    bool;
  _rear_seatbelt_buckled_is_valid_type rear_seatbelt_buckled_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__driver_seat_occupied(
    const bool & _arg)
  {
    this->driver_seat_occupied = _arg;
    return *this;
  }
  Type & set__driver_seat_occupied_is_valid(
    const bool & _arg)
  {
    this->driver_seat_occupied_is_valid = _arg;
    return *this;
  }
  Type & set__passenger_seat_occupied(
    const bool & _arg)
  {
    this->passenger_seat_occupied = _arg;
    return *this;
  }
  Type & set__passenger_seat_occupied_is_valid(
    const bool & _arg)
  {
    this->passenger_seat_occupied_is_valid = _arg;
    return *this;
  }
  Type & set__rear_seat_occupied(
    const bool & _arg)
  {
    this->rear_seat_occupied = _arg;
    return *this;
  }
  Type & set__rear_seat_occupied_is_valid(
    const bool & _arg)
  {
    this->rear_seat_occupied_is_valid = _arg;
    return *this;
  }
  Type & set__driver_seatbelt_buckled(
    const bool & _arg)
  {
    this->driver_seatbelt_buckled = _arg;
    return *this;
  }
  Type & set__driver_seatbelt_buckled_is_valid(
    const bool & _arg)
  {
    this->driver_seatbelt_buckled_is_valid = _arg;
    return *this;
  }
  Type & set__passenger_seatbelt_buckled(
    const bool & _arg)
  {
    this->passenger_seatbelt_buckled = _arg;
    return *this;
  }
  Type & set__passenger_seatbelt_buckled_is_valid(
    const bool & _arg)
  {
    this->passenger_seatbelt_buckled_is_valid = _arg;
    return *this;
  }
  Type & set__rear_seatbelt_buckled(
    const bool & _arg)
  {
    this->rear_seatbelt_buckled = _arg;
    return *this;
  }
  Type & set__rear_seatbelt_buckled_is_valid(
    const bool & _arg)
  {
    this->rear_seatbelt_buckled_is_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__OccupancyRpt
    std::shared_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__OccupancyRpt
    std::shared_ptr<pacmod_msgs::msg::OccupancyRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OccupancyRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->driver_seat_occupied != other.driver_seat_occupied) {
      return false;
    }
    if (this->driver_seat_occupied_is_valid != other.driver_seat_occupied_is_valid) {
      return false;
    }
    if (this->passenger_seat_occupied != other.passenger_seat_occupied) {
      return false;
    }
    if (this->passenger_seat_occupied_is_valid != other.passenger_seat_occupied_is_valid) {
      return false;
    }
    if (this->rear_seat_occupied != other.rear_seat_occupied) {
      return false;
    }
    if (this->rear_seat_occupied_is_valid != other.rear_seat_occupied_is_valid) {
      return false;
    }
    if (this->driver_seatbelt_buckled != other.driver_seatbelt_buckled) {
      return false;
    }
    if (this->driver_seatbelt_buckled_is_valid != other.driver_seatbelt_buckled_is_valid) {
      return false;
    }
    if (this->passenger_seatbelt_buckled != other.passenger_seatbelt_buckled) {
      return false;
    }
    if (this->passenger_seatbelt_buckled_is_valid != other.passenger_seatbelt_buckled_is_valid) {
      return false;
    }
    if (this->rear_seatbelt_buckled != other.rear_seatbelt_buckled) {
      return false;
    }
    if (this->rear_seatbelt_buckled_is_valid != other.rear_seatbelt_buckled_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const OccupancyRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OccupancyRpt_

// alias to use template instance with default allocator
using OccupancyRpt =
  pacmod_msgs::msg::OccupancyRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__OCCUPANCY_RPT__STRUCT_HPP_
