// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/PacmodCmd.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__PACMOD_CMD__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__PACMOD_CMD__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__PacmodCmd __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__PacmodCmd __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PacmodCmd_
{
  using Type = PacmodCmd_<ContainerAllocator>;

  explicit PacmodCmd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->f64_cmd = 0.0;
      this->ui16_cmd = 0;
      this->enable = false;
      this->clear = false;
      this->ignore = false;
    }
  }

  explicit PacmodCmd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->f64_cmd = 0.0;
      this->ui16_cmd = 0;
      this->enable = false;
      this->clear = false;
      this->ignore = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _f64_cmd_type =
    double;
  _f64_cmd_type f64_cmd;
  using _ui16_cmd_type =
    uint16_t;
  _ui16_cmd_type ui16_cmd;
  using _enable_type =
    bool;
  _enable_type enable;
  using _clear_type =
    bool;
  _clear_type clear;
  using _ignore_type =
    bool;
  _ignore_type ignore;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__f64_cmd(
    const double & _arg)
  {
    this->f64_cmd = _arg;
    return *this;
  }
  Type & set__ui16_cmd(
    const uint16_t & _arg)
  {
    this->ui16_cmd = _arg;
    return *this;
  }
  Type & set__enable(
    const bool & _arg)
  {
    this->enable = _arg;
    return *this;
  }
  Type & set__clear(
    const bool & _arg)
  {
    this->clear = _arg;
    return *this;
  }
  Type & set__ignore(
    const bool & _arg)
  {
    this->ignore = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t TURN_RIGHT =
    0u;
  static constexpr uint16_t TURN_NONE =
    1u;
  static constexpr uint16_t TURN_LEFT =
    2u;
  static constexpr uint16_t TURN_HAZARDS =
    3u;
  static constexpr uint16_t SHIFT_PARK =
    0u;
  static constexpr uint16_t SHIFT_REVERSE =
    1u;
  static constexpr uint16_t SHIFT_NEUTRAL =
    2u;
  static constexpr uint16_t SHIFT_FORWARD =
    3u;
  static constexpr uint16_t SHIFT_HIGH =
    3u;
  static constexpr uint16_t SHIFT_LOW =
    4u;

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::PacmodCmd_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::PacmodCmd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::PacmodCmd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::PacmodCmd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__PacmodCmd
    std::shared_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__PacmodCmd
    std::shared_ptr<pacmod_msgs::msg::PacmodCmd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PacmodCmd_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->f64_cmd != other.f64_cmd) {
      return false;
    }
    if (this->ui16_cmd != other.ui16_cmd) {
      return false;
    }
    if (this->enable != other.enable) {
      return false;
    }
    if (this->clear != other.clear) {
      return false;
    }
    if (this->ignore != other.ignore) {
      return false;
    }
    return true;
  }
  bool operator!=(const PacmodCmd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PacmodCmd_

// alias to use template instance with default allocator
using PacmodCmd =
  pacmod_msgs::msg::PacmodCmd_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::TURN_RIGHT;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::TURN_NONE;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::TURN_LEFT;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::TURN_HAZARDS;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::SHIFT_PARK;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::SHIFT_REVERSE;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::SHIFT_NEUTRAL;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::SHIFT_FORWARD;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::SHIFT_HIGH;
template<typename ContainerAllocator>
constexpr uint16_t PacmodCmd_<ContainerAllocator>::SHIFT_LOW;

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__PACMOD_CMD__STRUCT_HPP_
