// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/RearLightsRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__REAR_LIGHTS_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__REAR_LIGHTS_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__RearLightsRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__RearLightsRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RearLightsRpt_
{
  using Type = RearLightsRpt_<ContainerAllocator>;

  explicit RearLightsRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->brake_lights_on = false;
      this->brake_lights_on_is_valid = false;
      this->reverse_lights_on = false;
      this->reverse_lights_on_is_valid = false;
    }
  }

  explicit RearLightsRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->brake_lights_on = false;
      this->brake_lights_on_is_valid = false;
      this->reverse_lights_on = false;
      this->reverse_lights_on_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _brake_lights_on_type =
    bool;
  _brake_lights_on_type brake_lights_on;
  using _brake_lights_on_is_valid_type =
    bool;
  _brake_lights_on_is_valid_type brake_lights_on_is_valid;
  using _reverse_lights_on_type =
    bool;
  _reverse_lights_on_type reverse_lights_on;
  using _reverse_lights_on_is_valid_type =
    bool;
  _reverse_lights_on_is_valid_type reverse_lights_on_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__brake_lights_on(
    const bool & _arg)
  {
    this->brake_lights_on = _arg;
    return *this;
  }
  Type & set__brake_lights_on_is_valid(
    const bool & _arg)
  {
    this->brake_lights_on_is_valid = _arg;
    return *this;
  }
  Type & set__reverse_lights_on(
    const bool & _arg)
  {
    this->reverse_lights_on = _arg;
    return *this;
  }
  Type & set__reverse_lights_on_is_valid(
    const bool & _arg)
  {
    this->reverse_lights_on_is_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__RearLightsRpt
    std::shared_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__RearLightsRpt
    std::shared_ptr<pacmod_msgs::msg::RearLightsRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RearLightsRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->brake_lights_on != other.brake_lights_on) {
      return false;
    }
    if (this->brake_lights_on_is_valid != other.brake_lights_on_is_valid) {
      return false;
    }
    if (this->reverse_lights_on != other.reverse_lights_on) {
      return false;
    }
    if (this->reverse_lights_on_is_valid != other.reverse_lights_on_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const RearLightsRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RearLightsRpt_

// alias to use template instance with default allocator
using RearLightsRpt =
  pacmod_msgs::msg::RearLightsRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__REAR_LIGHTS_RPT__STRUCT_HPP_
