// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/ShiftAuxRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__SHIFT_AUX_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__SHIFT_AUX_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__ShiftAuxRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__ShiftAuxRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ShiftAuxRpt_
{
  using Type = ShiftAuxRpt_<ContainerAllocator>;

  explicit ShiftAuxRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->between_gears = false;
      this->between_gears_is_valid = false;
      this->stay_in_neutral_mode = false;
      this->stay_in_neutral_mode_is_valid = false;
      this->brake_interlock_active = false;
      this->brake_interlock_active_is_valid = false;
      this->speed_interlock_active = false;
      this->speed_interlock_active_is_valid = false;
      this->gear_number_avail = false;
      this->gear_number = 0;
    }
  }

  explicit ShiftAuxRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->between_gears = false;
      this->between_gears_is_valid = false;
      this->stay_in_neutral_mode = false;
      this->stay_in_neutral_mode_is_valid = false;
      this->brake_interlock_active = false;
      this->brake_interlock_active_is_valid = false;
      this->speed_interlock_active = false;
      this->speed_interlock_active_is_valid = false;
      this->gear_number_avail = false;
      this->gear_number = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _between_gears_type =
    bool;
  _between_gears_type between_gears;
  using _between_gears_is_valid_type =
    bool;
  _between_gears_is_valid_type between_gears_is_valid;
  using _stay_in_neutral_mode_type =
    bool;
  _stay_in_neutral_mode_type stay_in_neutral_mode;
  using _stay_in_neutral_mode_is_valid_type =
    bool;
  _stay_in_neutral_mode_is_valid_type stay_in_neutral_mode_is_valid;
  using _brake_interlock_active_type =
    bool;
  _brake_interlock_active_type brake_interlock_active;
  using _brake_interlock_active_is_valid_type =
    bool;
  _brake_interlock_active_is_valid_type brake_interlock_active_is_valid;
  using _speed_interlock_active_type =
    bool;
  _speed_interlock_active_type speed_interlock_active;
  using _speed_interlock_active_is_valid_type =
    bool;
  _speed_interlock_active_is_valid_type speed_interlock_active_is_valid;
  using _gear_number_avail_type =
    bool;
  _gear_number_avail_type gear_number_avail;
  using _gear_number_type =
    int8_t;
  _gear_number_type gear_number;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__between_gears(
    const bool & _arg)
  {
    this->between_gears = _arg;
    return *this;
  }
  Type & set__between_gears_is_valid(
    const bool & _arg)
  {
    this->between_gears_is_valid = _arg;
    return *this;
  }
  Type & set__stay_in_neutral_mode(
    const bool & _arg)
  {
    this->stay_in_neutral_mode = _arg;
    return *this;
  }
  Type & set__stay_in_neutral_mode_is_valid(
    const bool & _arg)
  {
    this->stay_in_neutral_mode_is_valid = _arg;
    return *this;
  }
  Type & set__brake_interlock_active(
    const bool & _arg)
  {
    this->brake_interlock_active = _arg;
    return *this;
  }
  Type & set__brake_interlock_active_is_valid(
    const bool & _arg)
  {
    this->brake_interlock_active_is_valid = _arg;
    return *this;
  }
  Type & set__speed_interlock_active(
    const bool & _arg)
  {
    this->speed_interlock_active = _arg;
    return *this;
  }
  Type & set__speed_interlock_active_is_valid(
    const bool & _arg)
  {
    this->speed_interlock_active_is_valid = _arg;
    return *this;
  }
  Type & set__gear_number_avail(
    const bool & _arg)
  {
    this->gear_number_avail = _arg;
    return *this;
  }
  Type & set__gear_number(
    const int8_t & _arg)
  {
    this->gear_number = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__ShiftAuxRpt
    std::shared_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__ShiftAuxRpt
    std::shared_ptr<pacmod_msgs::msg::ShiftAuxRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ShiftAuxRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->between_gears != other.between_gears) {
      return false;
    }
    if (this->between_gears_is_valid != other.between_gears_is_valid) {
      return false;
    }
    if (this->stay_in_neutral_mode != other.stay_in_neutral_mode) {
      return false;
    }
    if (this->stay_in_neutral_mode_is_valid != other.stay_in_neutral_mode_is_valid) {
      return false;
    }
    if (this->brake_interlock_active != other.brake_interlock_active) {
      return false;
    }
    if (this->brake_interlock_active_is_valid != other.brake_interlock_active_is_valid) {
      return false;
    }
    if (this->speed_interlock_active != other.speed_interlock_active) {
      return false;
    }
    if (this->speed_interlock_active_is_valid != other.speed_interlock_active_is_valid) {
      return false;
    }
    if (this->gear_number_avail != other.gear_number_avail) {
      return false;
    }
    if (this->gear_number != other.gear_number) {
      return false;
    }
    return true;
  }
  bool operator!=(const ShiftAuxRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ShiftAuxRpt_

// alias to use template instance with default allocator
using ShiftAuxRpt =
  pacmod_msgs::msg::ShiftAuxRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__SHIFT_AUX_RPT__STRUCT_HPP_
