// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SteerAuxRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__STEER_AUX_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__STEER_AUX_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SteerAuxRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SteerAuxRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SteerAuxRpt_
{
  using Type = SteerAuxRpt_<ContainerAllocator>;

  explicit SteerAuxRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->raw_position = 0.0;
      this->raw_position_is_valid = false;
      this->raw_torque = 0.0;
      this->raw_torque_is_valid = false;
      this->rotation_rate = 0.0;
      this->rotation_rate_is_valid = false;
      this->user_interaction = false;
      this->user_interaction_is_valid = false;
    }
  }

  explicit SteerAuxRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->raw_position = 0.0;
      this->raw_position_is_valid = false;
      this->raw_torque = 0.0;
      this->raw_torque_is_valid = false;
      this->rotation_rate = 0.0;
      this->rotation_rate_is_valid = false;
      this->user_interaction = false;
      this->user_interaction_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _raw_position_type =
    double;
  _raw_position_type raw_position;
  using _raw_position_is_valid_type =
    bool;
  _raw_position_is_valid_type raw_position_is_valid;
  using _raw_torque_type =
    double;
  _raw_torque_type raw_torque;
  using _raw_torque_is_valid_type =
    bool;
  _raw_torque_is_valid_type raw_torque_is_valid;
  using _rotation_rate_type =
    double;
  _rotation_rate_type rotation_rate;
  using _rotation_rate_is_valid_type =
    bool;
  _rotation_rate_is_valid_type rotation_rate_is_valid;
  using _user_interaction_type =
    bool;
  _user_interaction_type user_interaction;
  using _user_interaction_is_valid_type =
    bool;
  _user_interaction_is_valid_type user_interaction_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__raw_position(
    const double & _arg)
  {
    this->raw_position = _arg;
    return *this;
  }
  Type & set__raw_position_is_valid(
    const bool & _arg)
  {
    this->raw_position_is_valid = _arg;
    return *this;
  }
  Type & set__raw_torque(
    const double & _arg)
  {
    this->raw_torque = _arg;
    return *this;
  }
  Type & set__raw_torque_is_valid(
    const bool & _arg)
  {
    this->raw_torque_is_valid = _arg;
    return *this;
  }
  Type & set__rotation_rate(
    const double & _arg)
  {
    this->rotation_rate = _arg;
    return *this;
  }
  Type & set__rotation_rate_is_valid(
    const bool & _arg)
  {
    this->rotation_rate_is_valid = _arg;
    return *this;
  }
  Type & set__user_interaction(
    const bool & _arg)
  {
    this->user_interaction = _arg;
    return *this;
  }
  Type & set__user_interaction_is_valid(
    const bool & _arg)
  {
    this->user_interaction_is_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SteerAuxRpt
    std::shared_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SteerAuxRpt
    std::shared_ptr<pacmod_msgs::msg::SteerAuxRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SteerAuxRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->raw_position != other.raw_position) {
      return false;
    }
    if (this->raw_position_is_valid != other.raw_position_is_valid) {
      return false;
    }
    if (this->raw_torque != other.raw_torque) {
      return false;
    }
    if (this->raw_torque_is_valid != other.raw_torque_is_valid) {
      return false;
    }
    if (this->rotation_rate != other.rotation_rate) {
      return false;
    }
    if (this->rotation_rate_is_valid != other.rotation_rate_is_valid) {
      return false;
    }
    if (this->user_interaction != other.user_interaction) {
      return false;
    }
    if (this->user_interaction_is_valid != other.user_interaction_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const SteerAuxRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SteerAuxRpt_

// alias to use template instance with default allocator
using SteerAuxRpt =
  pacmod_msgs::msg::SteerAuxRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__STEER_AUX_RPT__STRUCT_HPP_
