// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SteeringPIDRpt2.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT2__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT2__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt2 __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt2 __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SteeringPIDRpt2_
{
  using Type = SteeringPIDRpt2_<ContainerAllocator>;

  explicit SteeringPIDRpt2_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->p_term = 0.0;
      this->i_term = 0.0;
      this->d_term = 0.0;
      this->all_terms = 0.0;
    }
  }

  explicit SteeringPIDRpt2_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->p_term = 0.0;
      this->i_term = 0.0;
      this->d_term = 0.0;
      this->all_terms = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _p_term_type =
    double;
  _p_term_type p_term;
  using _i_term_type =
    double;
  _i_term_type i_term;
  using _d_term_type =
    double;
  _d_term_type d_term;
  using _all_terms_type =
    double;
  _all_terms_type all_terms;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__p_term(
    const double & _arg)
  {
    this->p_term = _arg;
    return *this;
  }
  Type & set__i_term(
    const double & _arg)
  {
    this->i_term = _arg;
    return *this;
  }
  Type & set__d_term(
    const double & _arg)
  {
    this->d_term = _arg;
    return *this;
  }
  Type & set__all_terms(
    const double & _arg)
  {
    this->all_terms = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt2
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt2
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt2_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SteeringPIDRpt2_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->p_term != other.p_term) {
      return false;
    }
    if (this->i_term != other.i_term) {
      return false;
    }
    if (this->d_term != other.d_term) {
      return false;
    }
    if (this->all_terms != other.all_terms) {
      return false;
    }
    return true;
  }
  bool operator!=(const SteeringPIDRpt2_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SteeringPIDRpt2_

// alias to use template instance with default allocator
using SteeringPIDRpt2 =
  pacmod_msgs::msg::SteeringPIDRpt2_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT2__STRUCT_HPP_
