// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SteeringPIDRpt3.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT3__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT3__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt3 __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt3 __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SteeringPIDRpt3_
{
  using Type = SteeringPIDRpt3_<ContainerAllocator>;

  explicit SteeringPIDRpt3_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->new_torque = 0.0;
      this->str_angle_desired = 0.0;
      this->str_angle_actual = 0.0;
      this->error = 0.0;
    }
  }

  explicit SteeringPIDRpt3_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->new_torque = 0.0;
      this->str_angle_desired = 0.0;
      this->str_angle_actual = 0.0;
      this->error = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _new_torque_type =
    double;
  _new_torque_type new_torque;
  using _str_angle_desired_type =
    double;
  _str_angle_desired_type str_angle_desired;
  using _str_angle_actual_type =
    double;
  _str_angle_actual_type str_angle_actual;
  using _error_type =
    double;
  _error_type error;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__new_torque(
    const double & _arg)
  {
    this->new_torque = _arg;
    return *this;
  }
  Type & set__str_angle_desired(
    const double & _arg)
  {
    this->str_angle_desired = _arg;
    return *this;
  }
  Type & set__str_angle_actual(
    const double & _arg)
  {
    this->str_angle_actual = _arg;
    return *this;
  }
  Type & set__error(
    const double & _arg)
  {
    this->error = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt3
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt3
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt3_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SteeringPIDRpt3_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->new_torque != other.new_torque) {
      return false;
    }
    if (this->str_angle_desired != other.str_angle_desired) {
      return false;
    }
    if (this->str_angle_actual != other.str_angle_actual) {
      return false;
    }
    if (this->error != other.error) {
      return false;
    }
    return true;
  }
  bool operator!=(const SteeringPIDRpt3_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SteeringPIDRpt3_

// alias to use template instance with default allocator
using SteeringPIDRpt3 =
  pacmod_msgs::msg::SteeringPIDRpt3_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT3__STRUCT_HPP_
