// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SteeringPIDRpt4.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT4__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT4__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt4 __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt4 __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SteeringPIDRpt4_
{
  using Type = SteeringPIDRpt4_<ContainerAllocator>;

  explicit SteeringPIDRpt4_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->angular_velocity = 0.0;
      this->angular_acceleration = 0.0;
    }
  }

  explicit SteeringPIDRpt4_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->angular_velocity = 0.0;
      this->angular_acceleration = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _angular_velocity_type =
    double;
  _angular_velocity_type angular_velocity;
  using _angular_acceleration_type =
    double;
  _angular_acceleration_type angular_acceleration;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__angular_velocity(
    const double & _arg)
  {
    this->angular_velocity = _arg;
    return *this;
  }
  Type & set__angular_acceleration(
    const double & _arg)
  {
    this->angular_acceleration = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt4
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SteeringPIDRpt4
    std::shared_ptr<pacmod_msgs::msg::SteeringPIDRpt4_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SteeringPIDRpt4_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->angular_velocity != other.angular_velocity) {
      return false;
    }
    if (this->angular_acceleration != other.angular_acceleration) {
      return false;
    }
    return true;
  }
  bool operator!=(const SteeringPIDRpt4_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SteeringPIDRpt4_

// alias to use template instance with default allocator
using SteeringPIDRpt4 =
  pacmod_msgs::msg::SteeringPIDRpt4_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT4__STRUCT_HPP_
