// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from pacmod_msgs:msg/SystemRptFloat.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_FLOAT__BUILDER_HPP_
#define PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_FLOAT__BUILDER_HPP_

#include "pacmod_msgs/msg/detail/system_rpt_float__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace pacmod_msgs
{

namespace msg
{

namespace builder
{

class Init_SystemRptFloat_output
{
public:
  explicit Init_SystemRptFloat_output(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  ::pacmod_msgs::msg::SystemRptFloat output(::pacmod_msgs::msg::SystemRptFloat::_output_type arg)
  {
    msg_.output = std::move(arg);
    return std::move(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_command
{
public:
  explicit Init_SystemRptFloat_command(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_output command(::pacmod_msgs::msg::SystemRptFloat::_command_type arg)
  {
    msg_.command = std::move(arg);
    return Init_SystemRptFloat_output(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_manual_input
{
public:
  explicit Init_SystemRptFloat_manual_input(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_command manual_input(::pacmod_msgs::msg::SystemRptFloat::_manual_input_type arg)
  {
    msg_.manual_input = std::move(arg);
    return Init_SystemRptFloat_command(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_vehicle_fault
{
public:
  explicit Init_SystemRptFloat_vehicle_fault(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_manual_input vehicle_fault(::pacmod_msgs::msg::SystemRptFloat::_vehicle_fault_type arg)
  {
    msg_.vehicle_fault = std::move(arg);
    return Init_SystemRptFloat_manual_input(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_pacmod_fault
{
public:
  explicit Init_SystemRptFloat_pacmod_fault(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_vehicle_fault pacmod_fault(::pacmod_msgs::msg::SystemRptFloat::_pacmod_fault_type arg)
  {
    msg_.pacmod_fault = std::move(arg);
    return Init_SystemRptFloat_vehicle_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_output_reported_fault
{
public:
  explicit Init_SystemRptFloat_output_reported_fault(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_pacmod_fault output_reported_fault(::pacmod_msgs::msg::SystemRptFloat::_output_reported_fault_type arg)
  {
    msg_.output_reported_fault = std::move(arg);
    return Init_SystemRptFloat_pacmod_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_input_output_fault
{
public:
  explicit Init_SystemRptFloat_input_output_fault(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_output_reported_fault input_output_fault(::pacmod_msgs::msg::SystemRptFloat::_input_output_fault_type arg)
  {
    msg_.input_output_fault = std::move(arg);
    return Init_SystemRptFloat_output_reported_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_command_output_fault
{
public:
  explicit Init_SystemRptFloat_command_output_fault(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_input_output_fault command_output_fault(::pacmod_msgs::msg::SystemRptFloat::_command_output_fault_type arg)
  {
    msg_.command_output_fault = std::move(arg);
    return Init_SystemRptFloat_input_output_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_override_active
{
public:
  explicit Init_SystemRptFloat_override_active(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_command_output_fault override_active(::pacmod_msgs::msg::SystemRptFloat::_override_active_type arg)
  {
    msg_.override_active = std::move(arg);
    return Init_SystemRptFloat_command_output_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_enabled
{
public:
  explicit Init_SystemRptFloat_enabled(::pacmod_msgs::msg::SystemRptFloat & msg)
  : msg_(msg)
  {}
  Init_SystemRptFloat_override_active enabled(::pacmod_msgs::msg::SystemRptFloat::_enabled_type arg)
  {
    msg_.enabled = std::move(arg);
    return Init_SystemRptFloat_override_active(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

class Init_SystemRptFloat_header
{
public:
  Init_SystemRptFloat_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SystemRptFloat_enabled header(::pacmod_msgs::msg::SystemRptFloat::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_SystemRptFloat_enabled(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptFloat msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::pacmod_msgs::msg::SystemRptFloat>()
{
  return pacmod_msgs::msg::builder::Init_SystemRptFloat_header();
}

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_FLOAT__BUILDER_HPP_
