// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/TurnAuxRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__TURN_AUX_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__TURN_AUX_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__TurnAuxRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__TurnAuxRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TurnAuxRpt_
{
  using Type = TurnAuxRpt_<ContainerAllocator>;

  explicit TurnAuxRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->driver_blinker_bulb_on = false;
      this->driver_blinker_bulb_on_is_valid = false;
      this->passenger_blinker_bulb_on = false;
      this->passenger_blinker_bulb_on_is_valid = false;
    }
  }

  explicit TurnAuxRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->driver_blinker_bulb_on = false;
      this->driver_blinker_bulb_on_is_valid = false;
      this->passenger_blinker_bulb_on = false;
      this->passenger_blinker_bulb_on_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _driver_blinker_bulb_on_type =
    bool;
  _driver_blinker_bulb_on_type driver_blinker_bulb_on;
  using _driver_blinker_bulb_on_is_valid_type =
    bool;
  _driver_blinker_bulb_on_is_valid_type driver_blinker_bulb_on_is_valid;
  using _passenger_blinker_bulb_on_type =
    bool;
  _passenger_blinker_bulb_on_type passenger_blinker_bulb_on;
  using _passenger_blinker_bulb_on_is_valid_type =
    bool;
  _passenger_blinker_bulb_on_is_valid_type passenger_blinker_bulb_on_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__driver_blinker_bulb_on(
    const bool & _arg)
  {
    this->driver_blinker_bulb_on = _arg;
    return *this;
  }
  Type & set__driver_blinker_bulb_on_is_valid(
    const bool & _arg)
  {
    this->driver_blinker_bulb_on_is_valid = _arg;
    return *this;
  }
  Type & set__passenger_blinker_bulb_on(
    const bool & _arg)
  {
    this->passenger_blinker_bulb_on = _arg;
    return *this;
  }
  Type & set__passenger_blinker_bulb_on_is_valid(
    const bool & _arg)
  {
    this->passenger_blinker_bulb_on_is_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__TurnAuxRpt
    std::shared_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__TurnAuxRpt
    std::shared_ptr<pacmod_msgs::msg::TurnAuxRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TurnAuxRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->driver_blinker_bulb_on != other.driver_blinker_bulb_on) {
      return false;
    }
    if (this->driver_blinker_bulb_on_is_valid != other.driver_blinker_bulb_on_is_valid) {
      return false;
    }
    if (this->passenger_blinker_bulb_on != other.passenger_blinker_bulb_on) {
      return false;
    }
    if (this->passenger_blinker_bulb_on_is_valid != other.passenger_blinker_bulb_on_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const TurnAuxRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TurnAuxRpt_

// alias to use template instance with default allocator
using TurnAuxRpt =
  pacmod_msgs::msg::TurnAuxRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__TURN_AUX_RPT__STRUCT_HPP_
