// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/VehicleSpeedRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__VEHICLE_SPEED_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__VEHICLE_SPEED_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__VehicleSpeedRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__VehicleSpeedRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VehicleSpeedRpt_
{
  using Type = VehicleSpeedRpt_<ContainerAllocator>;

  explicit VehicleSpeedRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->vehicle_speed = 0.0;
      this->vehicle_speed_valid = false;
      std::fill<typename std::array<uint8_t, 2>::iterator, uint8_t>(this->vehicle_speed_raw.begin(), this->vehicle_speed_raw.end(), 0);
    }
  }

  explicit VehicleSpeedRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    vehicle_speed_raw(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->vehicle_speed = 0.0;
      this->vehicle_speed_valid = false;
      std::fill<typename std::array<uint8_t, 2>::iterator, uint8_t>(this->vehicle_speed_raw.begin(), this->vehicle_speed_raw.end(), 0);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _vehicle_speed_type =
    double;
  _vehicle_speed_type vehicle_speed;
  using _vehicle_speed_valid_type =
    bool;
  _vehicle_speed_valid_type vehicle_speed_valid;
  using _vehicle_speed_raw_type =
    std::array<uint8_t, 2>;
  _vehicle_speed_raw_type vehicle_speed_raw;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__vehicle_speed(
    const double & _arg)
  {
    this->vehicle_speed = _arg;
    return *this;
  }
  Type & set__vehicle_speed_valid(
    const bool & _arg)
  {
    this->vehicle_speed_valid = _arg;
    return *this;
  }
  Type & set__vehicle_speed_raw(
    const std::array<uint8_t, 2> & _arg)
  {
    this->vehicle_speed_raw = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__VehicleSpeedRpt
    std::shared_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__VehicleSpeedRpt
    std::shared_ptr<pacmod_msgs::msg::VehicleSpeedRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VehicleSpeedRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->vehicle_speed != other.vehicle_speed) {
      return false;
    }
    if (this->vehicle_speed_valid != other.vehicle_speed_valid) {
      return false;
    }
    if (this->vehicle_speed_raw != other.vehicle_speed_raw) {
      return false;
    }
    return true;
  }
  bool operator!=(const VehicleSpeedRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VehicleSpeedRpt_

// alias to use template instance with default allocator
using VehicleSpeedRpt =
  pacmod_msgs::msg::VehicleSpeedRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__VEHICLE_SPEED_RPT__STRUCT_HPP_
