// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/WiperAuxRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__WIPER_AUX_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__WIPER_AUX_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__WiperAuxRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__WiperAuxRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct WiperAuxRpt_
{
  using Type = WiperAuxRpt_<ContainerAllocator>;

  explicit WiperAuxRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_wiping = false;
      this->front_wiping_is_valid = false;
      this->front_spraying = false;
      this->front_spraying_is_valid = false;
      this->rear_wiping = false;
      this->rear_wiping_is_valid = false;
      this->rear_spraying = false;
      this->rear_spraying_is_valid = false;
      this->spray_near_empty = false;
      this->spray_near_empty_is_valid = false;
      this->spray_empty = false;
      this->spray_empty_is_valid = false;
    }
  }

  explicit WiperAuxRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_wiping = false;
      this->front_wiping_is_valid = false;
      this->front_spraying = false;
      this->front_spraying_is_valid = false;
      this->rear_wiping = false;
      this->rear_wiping_is_valid = false;
      this->rear_spraying = false;
      this->rear_spraying_is_valid = false;
      this->spray_near_empty = false;
      this->spray_near_empty_is_valid = false;
      this->spray_empty = false;
      this->spray_empty_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _front_wiping_type =
    bool;
  _front_wiping_type front_wiping;
  using _front_wiping_is_valid_type =
    bool;
  _front_wiping_is_valid_type front_wiping_is_valid;
  using _front_spraying_type =
    bool;
  _front_spraying_type front_spraying;
  using _front_spraying_is_valid_type =
    bool;
  _front_spraying_is_valid_type front_spraying_is_valid;
  using _rear_wiping_type =
    bool;
  _rear_wiping_type rear_wiping;
  using _rear_wiping_is_valid_type =
    bool;
  _rear_wiping_is_valid_type rear_wiping_is_valid;
  using _rear_spraying_type =
    bool;
  _rear_spraying_type rear_spraying;
  using _rear_spraying_is_valid_type =
    bool;
  _rear_spraying_is_valid_type rear_spraying_is_valid;
  using _spray_near_empty_type =
    bool;
  _spray_near_empty_type spray_near_empty;
  using _spray_near_empty_is_valid_type =
    bool;
  _spray_near_empty_is_valid_type spray_near_empty_is_valid;
  using _spray_empty_type =
    bool;
  _spray_empty_type spray_empty;
  using _spray_empty_is_valid_type =
    bool;
  _spray_empty_is_valid_type spray_empty_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__front_wiping(
    const bool & _arg)
  {
    this->front_wiping = _arg;
    return *this;
  }
  Type & set__front_wiping_is_valid(
    const bool & _arg)
  {
    this->front_wiping_is_valid = _arg;
    return *this;
  }
  Type & set__front_spraying(
    const bool & _arg)
  {
    this->front_spraying = _arg;
    return *this;
  }
  Type & set__front_spraying_is_valid(
    const bool & _arg)
  {
    this->front_spraying_is_valid = _arg;
    return *this;
  }
  Type & set__rear_wiping(
    const bool & _arg)
  {
    this->rear_wiping = _arg;
    return *this;
  }
  Type & set__rear_wiping_is_valid(
    const bool & _arg)
  {
    this->rear_wiping_is_valid = _arg;
    return *this;
  }
  Type & set__rear_spraying(
    const bool & _arg)
  {
    this->rear_spraying = _arg;
    return *this;
  }
  Type & set__rear_spraying_is_valid(
    const bool & _arg)
  {
    this->rear_spraying_is_valid = _arg;
    return *this;
  }
  Type & set__spray_near_empty(
    const bool & _arg)
  {
    this->spray_near_empty = _arg;
    return *this;
  }
  Type & set__spray_near_empty_is_valid(
    const bool & _arg)
  {
    this->spray_near_empty_is_valid = _arg;
    return *this;
  }
  Type & set__spray_empty(
    const bool & _arg)
  {
    this->spray_empty = _arg;
    return *this;
  }
  Type & set__spray_empty_is_valid(
    const bool & _arg)
  {
    this->spray_empty_is_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__WiperAuxRpt
    std::shared_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__WiperAuxRpt
    std::shared_ptr<pacmod_msgs::msg::WiperAuxRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WiperAuxRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->front_wiping != other.front_wiping) {
      return false;
    }
    if (this->front_wiping_is_valid != other.front_wiping_is_valid) {
      return false;
    }
    if (this->front_spraying != other.front_spraying) {
      return false;
    }
    if (this->front_spraying_is_valid != other.front_spraying_is_valid) {
      return false;
    }
    if (this->rear_wiping != other.rear_wiping) {
      return false;
    }
    if (this->rear_wiping_is_valid != other.rear_wiping_is_valid) {
      return false;
    }
    if (this->rear_spraying != other.rear_spraying) {
      return false;
    }
    if (this->rear_spraying_is_valid != other.rear_spraying_is_valid) {
      return false;
    }
    if (this->spray_near_empty != other.spray_near_empty) {
      return false;
    }
    if (this->spray_near_empty_is_valid != other.spray_near_empty_is_valid) {
      return false;
    }
    if (this->spray_empty != other.spray_empty) {
      return false;
    }
    if (this->spray_empty_is_valid != other.spray_empty_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const WiperAuxRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WiperAuxRpt_

// alias to use template instance with default allocator
using WiperAuxRpt =
  pacmod_msgs::msg::WiperAuxRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__WIPER_AUX_RPT__STRUCT_HPP_
