// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/BrakeAuxRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__BRAKE_AUX_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__BRAKE_AUX_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__BrakeAuxRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__BrakeAuxRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BrakeAuxRpt_
{
  using Type = BrakeAuxRpt_<ContainerAllocator>;

  explicit BrakeAuxRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->raw_pedal_pos = 0.0;
      this->raw_pedal_pos_is_valid = false;
      this->raw_pedal_force = 0.0;
      this->raw_pedal_force_is_valid = false;
      this->raw_brake_pressure = 0.0;
      this->raw_brake_pressure_is_valid = false;
      this->brake_on_off = false;
      this->brake_on_off_is_valid = false;
      this->user_interaction = false;
      this->user_interaction_is_valid = false;
    }
  }

  explicit BrakeAuxRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->raw_pedal_pos = 0.0;
      this->raw_pedal_pos_is_valid = false;
      this->raw_pedal_force = 0.0;
      this->raw_pedal_force_is_valid = false;
      this->raw_brake_pressure = 0.0;
      this->raw_brake_pressure_is_valid = false;
      this->brake_on_off = false;
      this->brake_on_off_is_valid = false;
      this->user_interaction = false;
      this->user_interaction_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _raw_pedal_pos_type =
    double;
  _raw_pedal_pos_type raw_pedal_pos;
  using _raw_pedal_pos_is_valid_type =
    bool;
  _raw_pedal_pos_is_valid_type raw_pedal_pos_is_valid;
  using _raw_pedal_force_type =
    double;
  _raw_pedal_force_type raw_pedal_force;
  using _raw_pedal_force_is_valid_type =
    bool;
  _raw_pedal_force_is_valid_type raw_pedal_force_is_valid;
  using _raw_brake_pressure_type =
    double;
  _raw_brake_pressure_type raw_brake_pressure;
  using _raw_brake_pressure_is_valid_type =
    bool;
  _raw_brake_pressure_is_valid_type raw_brake_pressure_is_valid;
  using _brake_on_off_type =
    bool;
  _brake_on_off_type brake_on_off;
  using _brake_on_off_is_valid_type =
    bool;
  _brake_on_off_is_valid_type brake_on_off_is_valid;
  using _user_interaction_type =
    bool;
  _user_interaction_type user_interaction;
  using _user_interaction_is_valid_type =
    bool;
  _user_interaction_is_valid_type user_interaction_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__raw_pedal_pos(
    const double & _arg)
  {
    this->raw_pedal_pos = _arg;
    return *this;
  }
  Type & set__raw_pedal_pos_is_valid(
    const bool & _arg)
  {
    this->raw_pedal_pos_is_valid = _arg;
    return *this;
  }
  Type & set__raw_pedal_force(
    const double & _arg)
  {
    this->raw_pedal_force = _arg;
    return *this;
  }
  Type & set__raw_pedal_force_is_valid(
    const bool & _arg)
  {
    this->raw_pedal_force_is_valid = _arg;
    return *this;
  }
  Type & set__raw_brake_pressure(
    const double & _arg)
  {
    this->raw_brake_pressure = _arg;
    return *this;
  }
  Type & set__raw_brake_pressure_is_valid(
    const bool & _arg)
  {
    this->raw_brake_pressure_is_valid = _arg;
    return *this;
  }
  Type & set__brake_on_off(
    const bool & _arg)
  {
    this->brake_on_off = _arg;
    return *this;
  }
  Type & set__brake_on_off_is_valid(
    const bool & _arg)
  {
    this->brake_on_off_is_valid = _arg;
    return *this;
  }
  Type & set__user_interaction(
    const bool & _arg)
  {
    this->user_interaction = _arg;
    return *this;
  }
  Type & set__user_interaction_is_valid(
    const bool & _arg)
  {
    this->user_interaction_is_valid = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__BrakeAuxRpt
    std::shared_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__BrakeAuxRpt
    std::shared_ptr<pacmod_msgs::msg::BrakeAuxRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BrakeAuxRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->raw_pedal_pos != other.raw_pedal_pos) {
      return false;
    }
    if (this->raw_pedal_pos_is_valid != other.raw_pedal_pos_is_valid) {
      return false;
    }
    if (this->raw_pedal_force != other.raw_pedal_force) {
      return false;
    }
    if (this->raw_pedal_force_is_valid != other.raw_pedal_force_is_valid) {
      return false;
    }
    if (this->raw_brake_pressure != other.raw_brake_pressure) {
      return false;
    }
    if (this->raw_brake_pressure_is_valid != other.raw_brake_pressure_is_valid) {
      return false;
    }
    if (this->brake_on_off != other.brake_on_off) {
      return false;
    }
    if (this->brake_on_off_is_valid != other.brake_on_off_is_valid) {
      return false;
    }
    if (this->user_interaction != other.user_interaction) {
      return false;
    }
    if (this->user_interaction_is_valid != other.user_interaction_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const BrakeAuxRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BrakeAuxRpt_

// alias to use template instance with default allocator
using BrakeAuxRpt =
  pacmod_msgs::msg::BrakeAuxRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__BRAKE_AUX_RPT__STRUCT_HPP_
