// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from pacmod_msgs:msg/GlobalRpt.idl
// generated code does not contain a copyright notice
#include "pacmod_msgs/msg/detail/global_rpt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
pacmod_msgs__msg__GlobalRpt__init(pacmod_msgs__msg__GlobalRpt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    pacmod_msgs__msg__GlobalRpt__fini(msg);
    return false;
  }
  // enabled
  // override_active
  // fault_active
  // config_fault_active
  // user_can_timeout
  // brake_can_timeout
  // steering_can_timeout
  // vehicle_can_timeout
  // subsystem_can_timeout
  // user_can_read_errors
  return true;
}

void
pacmod_msgs__msg__GlobalRpt__fini(pacmod_msgs__msg__GlobalRpt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // enabled
  // override_active
  // fault_active
  // config_fault_active
  // user_can_timeout
  // brake_can_timeout
  // steering_can_timeout
  // vehicle_can_timeout
  // subsystem_can_timeout
  // user_can_read_errors
}

pacmod_msgs__msg__GlobalRpt *
pacmod_msgs__msg__GlobalRpt__create()
{
  pacmod_msgs__msg__GlobalRpt * msg = (pacmod_msgs__msg__GlobalRpt *)malloc(sizeof(pacmod_msgs__msg__GlobalRpt));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(pacmod_msgs__msg__GlobalRpt));
  bool success = pacmod_msgs__msg__GlobalRpt__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
pacmod_msgs__msg__GlobalRpt__destroy(pacmod_msgs__msg__GlobalRpt * msg)
{
  if (msg) {
    pacmod_msgs__msg__GlobalRpt__fini(msg);
  }
  free(msg);
}


bool
pacmod_msgs__msg__GlobalRpt__Sequence__init(pacmod_msgs__msg__GlobalRpt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  pacmod_msgs__msg__GlobalRpt * data = NULL;
  if (size) {
    data = (pacmod_msgs__msg__GlobalRpt *)calloc(size, sizeof(pacmod_msgs__msg__GlobalRpt));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = pacmod_msgs__msg__GlobalRpt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        pacmod_msgs__msg__GlobalRpt__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
pacmod_msgs__msg__GlobalRpt__Sequence__fini(pacmod_msgs__msg__GlobalRpt__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      pacmod_msgs__msg__GlobalRpt__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

pacmod_msgs__msg__GlobalRpt__Sequence *
pacmod_msgs__msg__GlobalRpt__Sequence__create(size_t size)
{
  pacmod_msgs__msg__GlobalRpt__Sequence * array = (pacmod_msgs__msg__GlobalRpt__Sequence *)malloc(sizeof(pacmod_msgs__msg__GlobalRpt__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = pacmod_msgs__msg__GlobalRpt__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
pacmod_msgs__msg__GlobalRpt__Sequence__destroy(pacmod_msgs__msg__GlobalRpt__Sequence * array)
{
  if (array) {
    pacmod_msgs__msg__GlobalRpt__Sequence__fini(array);
  }
  free(array);
}
