// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/GlobalRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__GLOBAL_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__GLOBAL_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__GlobalRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__GlobalRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GlobalRpt_
{
  using Type = GlobalRpt_<ContainerAllocator>;

  explicit GlobalRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enabled = false;
      this->override_active = false;
      this->fault_active = false;
      this->config_fault_active = false;
      this->user_can_timeout = false;
      this->brake_can_timeout = false;
      this->steering_can_timeout = false;
      this->vehicle_can_timeout = false;
      this->subsystem_can_timeout = false;
      this->user_can_read_errors = false;
    }
  }

  explicit GlobalRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enabled = false;
      this->override_active = false;
      this->fault_active = false;
      this->config_fault_active = false;
      this->user_can_timeout = false;
      this->brake_can_timeout = false;
      this->steering_can_timeout = false;
      this->vehicle_can_timeout = false;
      this->subsystem_can_timeout = false;
      this->user_can_read_errors = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _enabled_type =
    bool;
  _enabled_type enabled;
  using _override_active_type =
    bool;
  _override_active_type override_active;
  using _fault_active_type =
    bool;
  _fault_active_type fault_active;
  using _config_fault_active_type =
    bool;
  _config_fault_active_type config_fault_active;
  using _user_can_timeout_type =
    bool;
  _user_can_timeout_type user_can_timeout;
  using _brake_can_timeout_type =
    bool;
  _brake_can_timeout_type brake_can_timeout;
  using _steering_can_timeout_type =
    bool;
  _steering_can_timeout_type steering_can_timeout;
  using _vehicle_can_timeout_type =
    bool;
  _vehicle_can_timeout_type vehicle_can_timeout;
  using _subsystem_can_timeout_type =
    bool;
  _subsystem_can_timeout_type subsystem_can_timeout;
  using _user_can_read_errors_type =
    bool;
  _user_can_read_errors_type user_can_read_errors;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__enabled(
    const bool & _arg)
  {
    this->enabled = _arg;
    return *this;
  }
  Type & set__override_active(
    const bool & _arg)
  {
    this->override_active = _arg;
    return *this;
  }
  Type & set__fault_active(
    const bool & _arg)
  {
    this->fault_active = _arg;
    return *this;
  }
  Type & set__config_fault_active(
    const bool & _arg)
  {
    this->config_fault_active = _arg;
    return *this;
  }
  Type & set__user_can_timeout(
    const bool & _arg)
  {
    this->user_can_timeout = _arg;
    return *this;
  }
  Type & set__brake_can_timeout(
    const bool & _arg)
  {
    this->brake_can_timeout = _arg;
    return *this;
  }
  Type & set__steering_can_timeout(
    const bool & _arg)
  {
    this->steering_can_timeout = _arg;
    return *this;
  }
  Type & set__vehicle_can_timeout(
    const bool & _arg)
  {
    this->vehicle_can_timeout = _arg;
    return *this;
  }
  Type & set__subsystem_can_timeout(
    const bool & _arg)
  {
    this->subsystem_can_timeout = _arg;
    return *this;
  }
  Type & set__user_can_read_errors(
    const bool & _arg)
  {
    this->user_can_read_errors = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::GlobalRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::GlobalRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::GlobalRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::GlobalRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__GlobalRpt
    std::shared_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__GlobalRpt
    std::shared_ptr<pacmod_msgs::msg::GlobalRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GlobalRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->enabled != other.enabled) {
      return false;
    }
    if (this->override_active != other.override_active) {
      return false;
    }
    if (this->fault_active != other.fault_active) {
      return false;
    }
    if (this->config_fault_active != other.config_fault_active) {
      return false;
    }
    if (this->user_can_timeout != other.user_can_timeout) {
      return false;
    }
    if (this->brake_can_timeout != other.brake_can_timeout) {
      return false;
    }
    if (this->steering_can_timeout != other.steering_can_timeout) {
      return false;
    }
    if (this->vehicle_can_timeout != other.vehicle_can_timeout) {
      return false;
    }
    if (this->subsystem_can_timeout != other.subsystem_can_timeout) {
      return false;
    }
    if (this->user_can_read_errors != other.user_can_read_errors) {
      return false;
    }
    return true;
  }
  bool operator!=(const GlobalRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GlobalRpt_

// alias to use template instance with default allocator
using GlobalRpt =
  pacmod_msgs::msg::GlobalRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__GLOBAL_RPT__STRUCT_HPP_
