// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/HeadlightAuxRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__HEADLIGHT_AUX_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__HEADLIGHT_AUX_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__HeadlightAuxRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__HeadlightAuxRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HeadlightAuxRpt_
{
  using Type = HeadlightAuxRpt_<ContainerAllocator>;

  explicit HeadlightAuxRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->headlights_on = false;
      this->headlights_on_is_valid = false;
      this->headlights_on_bright = false;
      this->headlights_on_bright_is_valid = false;
      this->fog_lights_on = false;
      this->fog_lights_on_is_valid = false;
      this->headlights_mode = 0;
      this->headlights_mode_is_valid = false;
    }
  }

  explicit HeadlightAuxRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->headlights_on = false;
      this->headlights_on_is_valid = false;
      this->headlights_on_bright = false;
      this->headlights_on_bright_is_valid = false;
      this->fog_lights_on = false;
      this->fog_lights_on_is_valid = false;
      this->headlights_mode = 0;
      this->headlights_mode_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _headlights_on_type =
    bool;
  _headlights_on_type headlights_on;
  using _headlights_on_is_valid_type =
    bool;
  _headlights_on_is_valid_type headlights_on_is_valid;
  using _headlights_on_bright_type =
    bool;
  _headlights_on_bright_type headlights_on_bright;
  using _headlights_on_bright_is_valid_type =
    bool;
  _headlights_on_bright_is_valid_type headlights_on_bright_is_valid;
  using _fog_lights_on_type =
    bool;
  _fog_lights_on_type fog_lights_on;
  using _fog_lights_on_is_valid_type =
    bool;
  _fog_lights_on_is_valid_type fog_lights_on_is_valid;
  using _headlights_mode_type =
    uint8_t;
  _headlights_mode_type headlights_mode;
  using _headlights_mode_is_valid_type =
    bool;
  _headlights_mode_is_valid_type headlights_mode_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__headlights_on(
    const bool & _arg)
  {
    this->headlights_on = _arg;
    return *this;
  }
  Type & set__headlights_on_is_valid(
    const bool & _arg)
  {
    this->headlights_on_is_valid = _arg;
    return *this;
  }
  Type & set__headlights_on_bright(
    const bool & _arg)
  {
    this->headlights_on_bright = _arg;
    return *this;
  }
  Type & set__headlights_on_bright_is_valid(
    const bool & _arg)
  {
    this->headlights_on_bright_is_valid = _arg;
    return *this;
  }
  Type & set__fog_lights_on(
    const bool & _arg)
  {
    this->fog_lights_on = _arg;
    return *this;
  }
  Type & set__fog_lights_on_is_valid(
    const bool & _arg)
  {
    this->fog_lights_on_is_valid = _arg;
    return *this;
  }
  Type & set__headlights_mode(
    const uint8_t & _arg)
  {
    this->headlights_mode = _arg;
    return *this;
  }
  Type & set__headlights_mode_is_valid(
    const bool & _arg)
  {
    this->headlights_mode_is_valid = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t HEADLIGHTS_OFF =
    0u;
  static constexpr uint8_t HEADLIGHTS_PARKING =
    1u;
  static constexpr uint8_t HEADLIGHTS_MANUAL =
    2u;
  static constexpr uint8_t HEADLIGHTS_AUTO =
    3u;

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__HeadlightAuxRpt
    std::shared_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__HeadlightAuxRpt
    std::shared_ptr<pacmod_msgs::msg::HeadlightAuxRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HeadlightAuxRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->headlights_on != other.headlights_on) {
      return false;
    }
    if (this->headlights_on_is_valid != other.headlights_on_is_valid) {
      return false;
    }
    if (this->headlights_on_bright != other.headlights_on_bright) {
      return false;
    }
    if (this->headlights_on_bright_is_valid != other.headlights_on_bright_is_valid) {
      return false;
    }
    if (this->fog_lights_on != other.fog_lights_on) {
      return false;
    }
    if (this->fog_lights_on_is_valid != other.fog_lights_on_is_valid) {
      return false;
    }
    if (this->headlights_mode != other.headlights_mode) {
      return false;
    }
    if (this->headlights_mode_is_valid != other.headlights_mode_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const HeadlightAuxRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HeadlightAuxRpt_

// alias to use template instance with default allocator
using HeadlightAuxRpt =
  pacmod_msgs::msg::HeadlightAuxRpt_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t HeadlightAuxRpt_<ContainerAllocator>::HEADLIGHTS_OFF;
template<typename ContainerAllocator>
constexpr uint8_t HeadlightAuxRpt_<ContainerAllocator>::HEADLIGHTS_PARKING;
template<typename ContainerAllocator>
constexpr uint8_t HeadlightAuxRpt_<ContainerAllocator>::HEADLIGHTS_MANUAL;
template<typename ContainerAllocator>
constexpr uint8_t HeadlightAuxRpt_<ContainerAllocator>::HEADLIGHTS_AUTO;

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__HEADLIGHT_AUX_RPT__STRUCT_HPP_
