// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/InteriorLightsRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__INTERIOR_LIGHTS_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__INTERIOR_LIGHTS_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__InteriorLightsRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__InteriorLightsRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InteriorLightsRpt_
{
  using Type = InteriorLightsRpt_<ContainerAllocator>;

  explicit InteriorLightsRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_dome_lights_on = false;
      this->front_dome_lights_on_is_valid = false;
      this->rear_dome_lights_on = false;
      this->rear_dome_lights_on_is_valid = false;
      this->mood_lights_on = false;
      this->mood_lights_on_is_valid = false;
      this->dim_level = 0;
      this->dim_level_is_valid = false;
    }
  }

  explicit InteriorLightsRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_dome_lights_on = false;
      this->front_dome_lights_on_is_valid = false;
      this->rear_dome_lights_on = false;
      this->rear_dome_lights_on_is_valid = false;
      this->mood_lights_on = false;
      this->mood_lights_on_is_valid = false;
      this->dim_level = 0;
      this->dim_level_is_valid = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _front_dome_lights_on_type =
    bool;
  _front_dome_lights_on_type front_dome_lights_on;
  using _front_dome_lights_on_is_valid_type =
    bool;
  _front_dome_lights_on_is_valid_type front_dome_lights_on_is_valid;
  using _rear_dome_lights_on_type =
    bool;
  _rear_dome_lights_on_type rear_dome_lights_on;
  using _rear_dome_lights_on_is_valid_type =
    bool;
  _rear_dome_lights_on_is_valid_type rear_dome_lights_on_is_valid;
  using _mood_lights_on_type =
    bool;
  _mood_lights_on_type mood_lights_on;
  using _mood_lights_on_is_valid_type =
    bool;
  _mood_lights_on_is_valid_type mood_lights_on_is_valid;
  using _dim_level_type =
    uint8_t;
  _dim_level_type dim_level;
  using _dim_level_is_valid_type =
    bool;
  _dim_level_is_valid_type dim_level_is_valid;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__front_dome_lights_on(
    const bool & _arg)
  {
    this->front_dome_lights_on = _arg;
    return *this;
  }
  Type & set__front_dome_lights_on_is_valid(
    const bool & _arg)
  {
    this->front_dome_lights_on_is_valid = _arg;
    return *this;
  }
  Type & set__rear_dome_lights_on(
    const bool & _arg)
  {
    this->rear_dome_lights_on = _arg;
    return *this;
  }
  Type & set__rear_dome_lights_on_is_valid(
    const bool & _arg)
  {
    this->rear_dome_lights_on_is_valid = _arg;
    return *this;
  }
  Type & set__mood_lights_on(
    const bool & _arg)
  {
    this->mood_lights_on = _arg;
    return *this;
  }
  Type & set__mood_lights_on_is_valid(
    const bool & _arg)
  {
    this->mood_lights_on_is_valid = _arg;
    return *this;
  }
  Type & set__dim_level(
    const uint8_t & _arg)
  {
    this->dim_level = _arg;
    return *this;
  }
  Type & set__dim_level_is_valid(
    const bool & _arg)
  {
    this->dim_level_is_valid = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t DIM_LEVEL_MIN =
    0u;
  static constexpr uint8_t DIM_LEVEL_1 =
    1u;
  static constexpr uint8_t DIM_LEVEL_2 =
    2u;
  static constexpr uint8_t DIM_LEVEL_3 =
    3u;
  static constexpr uint8_t DIM_LEVEL_4 =
    4u;
  static constexpr uint8_t DIM_LEVEL_5 =
    5u;
  static constexpr uint8_t DIM_LEVEL_6 =
    6u;
  static constexpr uint8_t DIM_LEVEL_7 =
    7u;
  static constexpr uint8_t DIM_LEVEL_8 =
    8u;
  static constexpr uint8_t DIM_LEVEL_9 =
    9u;
  static constexpr uint8_t DIM_LEVEL_10 =
    10u;
  static constexpr uint8_t DIM_LEVEL_11 =
    11u;
  static constexpr uint8_t DIM_LEVEL_MAX =
    12u;

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__InteriorLightsRpt
    std::shared_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__InteriorLightsRpt
    std::shared_ptr<pacmod_msgs::msg::InteriorLightsRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InteriorLightsRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->front_dome_lights_on != other.front_dome_lights_on) {
      return false;
    }
    if (this->front_dome_lights_on_is_valid != other.front_dome_lights_on_is_valid) {
      return false;
    }
    if (this->rear_dome_lights_on != other.rear_dome_lights_on) {
      return false;
    }
    if (this->rear_dome_lights_on_is_valid != other.rear_dome_lights_on_is_valid) {
      return false;
    }
    if (this->mood_lights_on != other.mood_lights_on) {
      return false;
    }
    if (this->mood_lights_on_is_valid != other.mood_lights_on_is_valid) {
      return false;
    }
    if (this->dim_level != other.dim_level) {
      return false;
    }
    if (this->dim_level_is_valid != other.dim_level_is_valid) {
      return false;
    }
    return true;
  }
  bool operator!=(const InteriorLightsRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InteriorLightsRpt_

// alias to use template instance with default allocator
using InteriorLightsRpt =
  pacmod_msgs::msg::InteriorLightsRpt_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_MIN;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_1;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_2;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_3;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_4;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_5;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_6;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_7;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_8;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_9;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_10;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_11;
template<typename ContainerAllocator>
constexpr uint8_t InteriorLightsRpt_<ContainerAllocator>::DIM_LEVEL_MAX;

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__INTERIOR_LIGHTS_RPT__STRUCT_HPP_
