// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/MotorRpt3.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__MOTOR_RPT3__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__MOTOR_RPT3__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__MotorRpt3 __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__MotorRpt3 __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MotorRpt3_
{
  using Type = MotorRpt3_<ContainerAllocator>;

  explicit MotorRpt3_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->torque_output = 0.0;
      this->torque_input = 0.0;
    }
  }

  explicit MotorRpt3_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->torque_output = 0.0;
      this->torque_input = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _torque_output_type =
    double;
  _torque_output_type torque_output;
  using _torque_input_type =
    double;
  _torque_input_type torque_input;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__torque_output(
    const double & _arg)
  {
    this->torque_output = _arg;
    return *this;
  }
  Type & set__torque_input(
    const double & _arg)
  {
    this->torque_input = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::MotorRpt3_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::MotorRpt3_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::MotorRpt3_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::MotorRpt3_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__MotorRpt3
    std::shared_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__MotorRpt3
    std::shared_ptr<pacmod_msgs::msg::MotorRpt3_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotorRpt3_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->torque_output != other.torque_output) {
      return false;
    }
    if (this->torque_input != other.torque_input) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotorRpt3_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotorRpt3_

// alias to use template instance with default allocator
using MotorRpt3 =
  pacmod_msgs::msg::MotorRpt3_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__MOTOR_RPT3__STRUCT_HPP_
