// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from pacmod_msgs:msg/SteeringPIDRpt2.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT2__FUNCTIONS_H_
#define PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT2__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "pacmod_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "pacmod_msgs/msg/detail/steering_pid_rpt2__struct.h"

/// Initialize msg/SteeringPIDRpt2 message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * pacmod_msgs__msg__SteeringPIDRpt2
 * )) before or use
 * pacmod_msgs__msg__SteeringPIDRpt2__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__SteeringPIDRpt2__init(pacmod_msgs__msg__SteeringPIDRpt2 * msg);

/// Finalize msg/SteeringPIDRpt2 message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__SteeringPIDRpt2__fini(pacmod_msgs__msg__SteeringPIDRpt2 * msg);

/// Create msg/SteeringPIDRpt2 message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * pacmod_msgs__msg__SteeringPIDRpt2__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
pacmod_msgs__msg__SteeringPIDRpt2 *
pacmod_msgs__msg__SteeringPIDRpt2__create();

/// Destroy msg/SteeringPIDRpt2 message.
/**
 * It calls
 * pacmod_msgs__msg__SteeringPIDRpt2__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__SteeringPIDRpt2__destroy(pacmod_msgs__msg__SteeringPIDRpt2 * msg);


/// Initialize array of msg/SteeringPIDRpt2 messages.
/**
 * It allocates the memory for the number of elements and calls
 * pacmod_msgs__msg__SteeringPIDRpt2__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
bool
pacmod_msgs__msg__SteeringPIDRpt2__Sequence__init(pacmod_msgs__msg__SteeringPIDRpt2__Sequence * array, size_t size);

/// Finalize array of msg/SteeringPIDRpt2 messages.
/**
 * It calls
 * pacmod_msgs__msg__SteeringPIDRpt2__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__SteeringPIDRpt2__Sequence__fini(pacmod_msgs__msg__SteeringPIDRpt2__Sequence * array);

/// Create array of msg/SteeringPIDRpt2 messages.
/**
 * It allocates the memory for the array and calls
 * pacmod_msgs__msg__SteeringPIDRpt2__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
pacmod_msgs__msg__SteeringPIDRpt2__Sequence *
pacmod_msgs__msg__SteeringPIDRpt2__Sequence__create(size_t size);

/// Destroy array of msg/SteeringPIDRpt2 messages.
/**
 * It calls
 * pacmod_msgs__msg__SteeringPIDRpt2__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_pacmod_msgs
void
pacmod_msgs__msg__SteeringPIDRpt2__Sequence__destroy(pacmod_msgs__msg__SteeringPIDRpt2__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // PACMOD_MSGS__MSG__DETAIL__STEERING_PID_RPT2__FUNCTIONS_H_
