// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SystemCmdBool.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__SYSTEM_CMD_BOOL__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__SYSTEM_CMD_BOOL__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SystemCmdBool __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SystemCmdBool __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemCmdBool_
{
  using Type = SystemCmdBool_<ContainerAllocator>;

  explicit SystemCmdBool_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enable = false;
      this->ignore_overrides = false;
      this->clear_override = false;
      this->clear_faults = false;
      this->command = false;
    }
  }

  explicit SystemCmdBool_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enable = false;
      this->ignore_overrides = false;
      this->clear_override = false;
      this->clear_faults = false;
      this->command = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _enable_type =
    bool;
  _enable_type enable;
  using _ignore_overrides_type =
    bool;
  _ignore_overrides_type ignore_overrides;
  using _clear_override_type =
    bool;
  _clear_override_type clear_override;
  using _clear_faults_type =
    bool;
  _clear_faults_type clear_faults;
  using _command_type =
    bool;
  _command_type command;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__enable(
    const bool & _arg)
  {
    this->enable = _arg;
    return *this;
  }
  Type & set__ignore_overrides(
    const bool & _arg)
  {
    this->ignore_overrides = _arg;
    return *this;
  }
  Type & set__clear_override(
    const bool & _arg)
  {
    this->clear_override = _arg;
    return *this;
  }
  Type & set__clear_faults(
    const bool & _arg)
  {
    this->clear_faults = _arg;
    return *this;
  }
  Type & set__command(
    const bool & _arg)
  {
    this->command = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SystemCmdBool
    std::shared_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SystemCmdBool
    std::shared_ptr<pacmod_msgs::msg::SystemCmdBool_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemCmdBool_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->enable != other.enable) {
      return false;
    }
    if (this->ignore_overrides != other.ignore_overrides) {
      return false;
    }
    if (this->clear_override != other.clear_override) {
      return false;
    }
    if (this->clear_faults != other.clear_faults) {
      return false;
    }
    if (this->command != other.command) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemCmdBool_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemCmdBool_

// alias to use template instance with default allocator
using SystemCmdBool =
  pacmod_msgs::msg::SystemCmdBool_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__SYSTEM_CMD_BOOL__STRUCT_HPP_
