// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SystemCmdInt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__SYSTEM_CMD_INT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__SYSTEM_CMD_INT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SystemCmdInt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SystemCmdInt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemCmdInt_
{
  using Type = SystemCmdInt_<ContainerAllocator>;

  explicit SystemCmdInt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enable = false;
      this->ignore_overrides = false;
      this->clear_override = false;
      this->clear_faults = false;
      this->command = 0;
    }
  }

  explicit SystemCmdInt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enable = false;
      this->ignore_overrides = false;
      this->clear_override = false;
      this->clear_faults = false;
      this->command = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _enable_type =
    bool;
  _enable_type enable;
  using _ignore_overrides_type =
    bool;
  _ignore_overrides_type ignore_overrides;
  using _clear_override_type =
    bool;
  _clear_override_type clear_override;
  using _clear_faults_type =
    bool;
  _clear_faults_type clear_faults;
  using _command_type =
    uint16_t;
  _command_type command;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__enable(
    const bool & _arg)
  {
    this->enable = _arg;
    return *this;
  }
  Type & set__ignore_overrides(
    const bool & _arg)
  {
    this->ignore_overrides = _arg;
    return *this;
  }
  Type & set__clear_override(
    const bool & _arg)
  {
    this->clear_override = _arg;
    return *this;
  }
  Type & set__clear_faults(
    const bool & _arg)
  {
    this->clear_faults = _arg;
    return *this;
  }
  Type & set__command(
    const uint16_t & _arg)
  {
    this->command = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t CRUISE_CONTROL_NONE =
    0u;
  static constexpr uint16_t CRUISE_CONTROL_CNCL =
    1u;
  static constexpr uint16_t CRUISE_CONTROL_ACC_FURTHER =
    2u;
  static constexpr uint16_t CRUISE_CONTROL_ACC_CLOSER =
    3u;
  static constexpr uint16_t CRUISE_CONTROL_SET_DEC =
    4u;
  static constexpr uint16_t CRUISE_CONTROL_RES_INC =
    5u;
  static constexpr uint16_t DASH_CONTROL_NONE =
    0u;
  static constexpr uint16_t DASH_CONTROL_OK =
    1u;
  static constexpr uint16_t DASH_CONTROL_LEFT =
    2u;
  static constexpr uint16_t DASH_CONTROL_RIGHT =
    3u;
  static constexpr uint16_t DASH_CONTROL_UP =
    4u;
  static constexpr uint16_t DASH_CONTROL_DOWN =
    5u;
  static constexpr uint16_t HEADLIGHTS_OFF =
    0u;
  static constexpr uint16_t HEADLIGHTS_PARKING_ONLY =
    1u;
  static constexpr uint16_t HEADLIGHTS_MANUAL_LOW =
    2u;
  static constexpr uint16_t HEADLIGHTS_MANUAL_HIGH =
    3u;
  static constexpr uint16_t HEADLIGHTS_AUTO_LOW =
    4u;
  static constexpr uint16_t HEADLIGHTS_AUTO_HIGH =
    5u;
  static constexpr uint16_t MEDIA_CONTROL_NONE =
    0u;
  static constexpr uint16_t MEDIA_CONTROL_VOICE_COMMAND =
    1u;
  static constexpr uint16_t MEDIA_CONTROL_MUTE =
    2u;
  static constexpr uint16_t MEDIA_CONTROL_PREV_TRACK_ANSWER =
    3u;
  static constexpr uint16_t MEDIA_CONTROL_NEXT_TRACK_HANG_UP =
    4u;
  static constexpr uint16_t MEDIA_CONTROL_VOL_UP =
    5u;
  static constexpr uint16_t MEDIA_CONTROL_VOL_DOWN =
    6u;
  static constexpr uint16_t SHIFT_PARK =
    0u;
  static constexpr uint16_t SHIFT_REVERSE =
    1u;
  static constexpr uint16_t SHIFT_NEUTRAL =
    2u;
  static constexpr uint16_t SHIFT_HIGH =
    3u;
  static constexpr uint16_t SHIFT_FORWARD =
    3u;
  static constexpr uint16_t SHIFT_LOW =
    4u;
  static constexpr uint16_t SHIFT_NONE =
    7u;
  static constexpr uint16_t TURN_RIGHT =
    0u;
  static constexpr uint16_t TURN_NONE =
    1u;
  static constexpr uint16_t TURN_LEFT =
    2u;
  static constexpr uint16_t TURN_HAZARDS =
    3u;
  static constexpr uint16_t DOOR_NEUTRAL =
    0u;
  static constexpr uint16_t DOOR_OPEN =
    1u;
  static constexpr uint16_t DOOR_CLOSE =
    2u;
  static constexpr uint16_t WIPERS_OFF =
    0u;
  static constexpr uint16_t WIPERS_INT_1 =
    1u;
  static constexpr uint16_t WIPERS_INT_2 =
    2u;
  static constexpr uint16_t WIPERS_INT_3 =
    3u;
  static constexpr uint16_t WIPERS_INT_4 =
    4u;
  static constexpr uint16_t WIPERS_INT_5 =
    5u;
  static constexpr uint16_t WIPERS_INT_6 =
    6u;
  static constexpr uint16_t WIPERS_MEDIUM =
    7u;
  static constexpr uint16_t WIPERS_HIGH =
    8u;

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SystemCmdInt
    std::shared_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SystemCmdInt
    std::shared_ptr<pacmod_msgs::msg::SystemCmdInt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemCmdInt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->enable != other.enable) {
      return false;
    }
    if (this->ignore_overrides != other.ignore_overrides) {
      return false;
    }
    if (this->clear_override != other.clear_override) {
      return false;
    }
    if (this->clear_faults != other.clear_faults) {
      return false;
    }
    if (this->command != other.command) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemCmdInt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemCmdInt_

// alias to use template instance with default allocator
using SystemCmdInt =
  pacmod_msgs::msg::SystemCmdInt_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::CRUISE_CONTROL_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::CRUISE_CONTROL_CNCL;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::CRUISE_CONTROL_ACC_FURTHER;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::CRUISE_CONTROL_ACC_CLOSER;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::CRUISE_CONTROL_SET_DEC;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::CRUISE_CONTROL_RES_INC;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DASH_CONTROL_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DASH_CONTROL_OK;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DASH_CONTROL_LEFT;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DASH_CONTROL_RIGHT;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DASH_CONTROL_UP;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DASH_CONTROL_DOWN;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::HEADLIGHTS_OFF;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::HEADLIGHTS_PARKING_ONLY;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::HEADLIGHTS_MANUAL_LOW;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::HEADLIGHTS_MANUAL_HIGH;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::HEADLIGHTS_AUTO_LOW;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::HEADLIGHTS_AUTO_HIGH;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::MEDIA_CONTROL_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::MEDIA_CONTROL_VOICE_COMMAND;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::MEDIA_CONTROL_MUTE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::MEDIA_CONTROL_PREV_TRACK_ANSWER;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::MEDIA_CONTROL_NEXT_TRACK_HANG_UP;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::MEDIA_CONTROL_VOL_UP;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::MEDIA_CONTROL_VOL_DOWN;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::SHIFT_PARK;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::SHIFT_REVERSE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::SHIFT_NEUTRAL;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::SHIFT_HIGH;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::SHIFT_FORWARD;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::SHIFT_LOW;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::SHIFT_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::TURN_RIGHT;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::TURN_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::TURN_LEFT;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::TURN_HAZARDS;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DOOR_NEUTRAL;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DOOR_OPEN;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::DOOR_CLOSE;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_OFF;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_INT_1;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_INT_2;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_INT_3;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_INT_4;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_INT_5;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_INT_6;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_MEDIUM;
template<typename ContainerAllocator>
constexpr uint16_t SystemCmdInt_<ContainerAllocator>::WIPERS_HIGH;

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__SYSTEM_CMD_INT__STRUCT_HPP_
