// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SystemRptBool.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_BOOL__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_BOOL__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SystemRptBool __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SystemRptBool __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemRptBool_
{
  using Type = SystemRptBool_<ContainerAllocator>;

  explicit SystemRptBool_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enabled = false;
      this->override_active = false;
      this->command_output_fault = false;
      this->input_output_fault = false;
      this->output_reported_fault = false;
      this->pacmod_fault = false;
      this->vehicle_fault = false;
      this->manual_input = false;
      this->command = false;
      this->output = false;
    }
  }

  explicit SystemRptBool_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enabled = false;
      this->override_active = false;
      this->command_output_fault = false;
      this->input_output_fault = false;
      this->output_reported_fault = false;
      this->pacmod_fault = false;
      this->vehicle_fault = false;
      this->manual_input = false;
      this->command = false;
      this->output = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _enabled_type =
    bool;
  _enabled_type enabled;
  using _override_active_type =
    bool;
  _override_active_type override_active;
  using _command_output_fault_type =
    bool;
  _command_output_fault_type command_output_fault;
  using _input_output_fault_type =
    bool;
  _input_output_fault_type input_output_fault;
  using _output_reported_fault_type =
    bool;
  _output_reported_fault_type output_reported_fault;
  using _pacmod_fault_type =
    bool;
  _pacmod_fault_type pacmod_fault;
  using _vehicle_fault_type =
    bool;
  _vehicle_fault_type vehicle_fault;
  using _manual_input_type =
    bool;
  _manual_input_type manual_input;
  using _command_type =
    bool;
  _command_type command;
  using _output_type =
    bool;
  _output_type output;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__enabled(
    const bool & _arg)
  {
    this->enabled = _arg;
    return *this;
  }
  Type & set__override_active(
    const bool & _arg)
  {
    this->override_active = _arg;
    return *this;
  }
  Type & set__command_output_fault(
    const bool & _arg)
  {
    this->command_output_fault = _arg;
    return *this;
  }
  Type & set__input_output_fault(
    const bool & _arg)
  {
    this->input_output_fault = _arg;
    return *this;
  }
  Type & set__output_reported_fault(
    const bool & _arg)
  {
    this->output_reported_fault = _arg;
    return *this;
  }
  Type & set__pacmod_fault(
    const bool & _arg)
  {
    this->pacmod_fault = _arg;
    return *this;
  }
  Type & set__vehicle_fault(
    const bool & _arg)
  {
    this->vehicle_fault = _arg;
    return *this;
  }
  Type & set__manual_input(
    const bool & _arg)
  {
    this->manual_input = _arg;
    return *this;
  }
  Type & set__command(
    const bool & _arg)
  {
    this->command = _arg;
    return *this;
  }
  Type & set__output(
    const bool & _arg)
  {
    this->output = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SystemRptBool_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SystemRptBool_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemRptBool_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemRptBool_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SystemRptBool
    std::shared_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SystemRptBool
    std::shared_ptr<pacmod_msgs::msg::SystemRptBool_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemRptBool_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->enabled != other.enabled) {
      return false;
    }
    if (this->override_active != other.override_active) {
      return false;
    }
    if (this->command_output_fault != other.command_output_fault) {
      return false;
    }
    if (this->input_output_fault != other.input_output_fault) {
      return false;
    }
    if (this->output_reported_fault != other.output_reported_fault) {
      return false;
    }
    if (this->pacmod_fault != other.pacmod_fault) {
      return false;
    }
    if (this->vehicle_fault != other.vehicle_fault) {
      return false;
    }
    if (this->manual_input != other.manual_input) {
      return false;
    }
    if (this->command != other.command) {
      return false;
    }
    if (this->output != other.output) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemRptBool_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemRptBool_

// alias to use template instance with default allocator
using SystemRptBool =
  pacmod_msgs::msg::SystemRptBool_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_BOOL__STRUCT_HPP_
