// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from pacmod_msgs:msg/SystemRptInt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_INT__BUILDER_HPP_
#define PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_INT__BUILDER_HPP_

#include "pacmod_msgs/msg/detail/system_rpt_int__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace pacmod_msgs
{

namespace msg
{

namespace builder
{

class Init_SystemRptInt_output
{
public:
  explicit Init_SystemRptInt_output(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  ::pacmod_msgs::msg::SystemRptInt output(::pacmod_msgs::msg::SystemRptInt::_output_type arg)
  {
    msg_.output = std::move(arg);
    return std::move(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_command
{
public:
  explicit Init_SystemRptInt_command(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_output command(::pacmod_msgs::msg::SystemRptInt::_command_type arg)
  {
    msg_.command = std::move(arg);
    return Init_SystemRptInt_output(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_manual_input
{
public:
  explicit Init_SystemRptInt_manual_input(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_command manual_input(::pacmod_msgs::msg::SystemRptInt::_manual_input_type arg)
  {
    msg_.manual_input = std::move(arg);
    return Init_SystemRptInt_command(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_vehicle_fault
{
public:
  explicit Init_SystemRptInt_vehicle_fault(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_manual_input vehicle_fault(::pacmod_msgs::msg::SystemRptInt::_vehicle_fault_type arg)
  {
    msg_.vehicle_fault = std::move(arg);
    return Init_SystemRptInt_manual_input(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_pacmod_fault
{
public:
  explicit Init_SystemRptInt_pacmod_fault(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_vehicle_fault pacmod_fault(::pacmod_msgs::msg::SystemRptInt::_pacmod_fault_type arg)
  {
    msg_.pacmod_fault = std::move(arg);
    return Init_SystemRptInt_vehicle_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_output_reported_fault
{
public:
  explicit Init_SystemRptInt_output_reported_fault(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_pacmod_fault output_reported_fault(::pacmod_msgs::msg::SystemRptInt::_output_reported_fault_type arg)
  {
    msg_.output_reported_fault = std::move(arg);
    return Init_SystemRptInt_pacmod_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_input_output_fault
{
public:
  explicit Init_SystemRptInt_input_output_fault(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_output_reported_fault input_output_fault(::pacmod_msgs::msg::SystemRptInt::_input_output_fault_type arg)
  {
    msg_.input_output_fault = std::move(arg);
    return Init_SystemRptInt_output_reported_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_command_output_fault
{
public:
  explicit Init_SystemRptInt_command_output_fault(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_input_output_fault command_output_fault(::pacmod_msgs::msg::SystemRptInt::_command_output_fault_type arg)
  {
    msg_.command_output_fault = std::move(arg);
    return Init_SystemRptInt_input_output_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_override_active
{
public:
  explicit Init_SystemRptInt_override_active(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_command_output_fault override_active(::pacmod_msgs::msg::SystemRptInt::_override_active_type arg)
  {
    msg_.override_active = std::move(arg);
    return Init_SystemRptInt_command_output_fault(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_enabled
{
public:
  explicit Init_SystemRptInt_enabled(::pacmod_msgs::msg::SystemRptInt & msg)
  : msg_(msg)
  {}
  Init_SystemRptInt_override_active enabled(::pacmod_msgs::msg::SystemRptInt::_enabled_type arg)
  {
    msg_.enabled = std::move(arg);
    return Init_SystemRptInt_override_active(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

class Init_SystemRptInt_header
{
public:
  Init_SystemRptInt_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SystemRptInt_enabled header(::pacmod_msgs::msg::SystemRptInt::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_SystemRptInt_enabled(msg_);
  }

private:
  ::pacmod_msgs::msg::SystemRptInt msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::pacmod_msgs::msg::SystemRptInt>()
{
  return pacmod_msgs::msg::builder::Init_SystemRptInt_header();
}

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_INT__BUILDER_HPP_
