// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/SystemRptInt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_INT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_INT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__SystemRptInt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__SystemRptInt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SystemRptInt_
{
  using Type = SystemRptInt_<ContainerAllocator>;

  explicit SystemRptInt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enabled = false;
      this->override_active = false;
      this->command_output_fault = false;
      this->input_output_fault = false;
      this->output_reported_fault = false;
      this->pacmod_fault = false;
      this->vehicle_fault = false;
      this->manual_input = 0;
      this->command = 0;
      this->output = 0;
    }
  }

  explicit SystemRptInt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->enabled = false;
      this->override_active = false;
      this->command_output_fault = false;
      this->input_output_fault = false;
      this->output_reported_fault = false;
      this->pacmod_fault = false;
      this->vehicle_fault = false;
      this->manual_input = 0;
      this->command = 0;
      this->output = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _enabled_type =
    bool;
  _enabled_type enabled;
  using _override_active_type =
    bool;
  _override_active_type override_active;
  using _command_output_fault_type =
    bool;
  _command_output_fault_type command_output_fault;
  using _input_output_fault_type =
    bool;
  _input_output_fault_type input_output_fault;
  using _output_reported_fault_type =
    bool;
  _output_reported_fault_type output_reported_fault;
  using _pacmod_fault_type =
    bool;
  _pacmod_fault_type pacmod_fault;
  using _vehicle_fault_type =
    bool;
  _vehicle_fault_type vehicle_fault;
  using _manual_input_type =
    uint16_t;
  _manual_input_type manual_input;
  using _command_type =
    uint16_t;
  _command_type command;
  using _output_type =
    uint16_t;
  _output_type output;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__enabled(
    const bool & _arg)
  {
    this->enabled = _arg;
    return *this;
  }
  Type & set__override_active(
    const bool & _arg)
  {
    this->override_active = _arg;
    return *this;
  }
  Type & set__command_output_fault(
    const bool & _arg)
  {
    this->command_output_fault = _arg;
    return *this;
  }
  Type & set__input_output_fault(
    const bool & _arg)
  {
    this->input_output_fault = _arg;
    return *this;
  }
  Type & set__output_reported_fault(
    const bool & _arg)
  {
    this->output_reported_fault = _arg;
    return *this;
  }
  Type & set__pacmod_fault(
    const bool & _arg)
  {
    this->pacmod_fault = _arg;
    return *this;
  }
  Type & set__vehicle_fault(
    const bool & _arg)
  {
    this->vehicle_fault = _arg;
    return *this;
  }
  Type & set__manual_input(
    const uint16_t & _arg)
  {
    this->manual_input = _arg;
    return *this;
  }
  Type & set__command(
    const uint16_t & _arg)
  {
    this->command = _arg;
    return *this;
  }
  Type & set__output(
    const uint16_t & _arg)
  {
    this->output = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t CRUISE_CONTROL_NONE =
    0u;
  static constexpr uint16_t CRUISE_CONTROL_CNCL =
    1u;
  static constexpr uint16_t CRUISE_CONTROL_ACC_FURTHER =
    2u;
  static constexpr uint16_t CRUISE_CONTROL_ACC_CLOSER =
    3u;
  static constexpr uint16_t CRUISE_CONTROL_SET_DEC =
    4u;
  static constexpr uint16_t CRUISE_CONTROL_RES_INC =
    5u;
  static constexpr uint16_t DASH_CONTROL_NONE =
    0u;
  static constexpr uint16_t DASH_CONTROL_OK =
    1u;
  static constexpr uint16_t DASH_CONTROL_LEFT =
    2u;
  static constexpr uint16_t DASH_CONTROL_RIGHT =
    3u;
  static constexpr uint16_t DASH_CONTROL_UP =
    4u;
  static constexpr uint16_t DASH_CONTROL_DOWN =
    5u;
  static constexpr uint16_t HEADLIGHTS_OFF =
    0u;
  static constexpr uint16_t HEADLIGHTS_PARKING_ONLY =
    1u;
  static constexpr uint16_t HEADLIGHTS_MANUAL_LOW =
    2u;
  static constexpr uint16_t HEADLIGHTS_MANUAL_HIGH =
    3u;
  static constexpr uint16_t HEADLIGHTS_AUTO_LOW =
    4u;
  static constexpr uint16_t HEADLIGHTS_AUTO_HIGH =
    5u;
  static constexpr uint16_t MEDIA_CONTROL_NONE =
    0u;
  static constexpr uint16_t MEDIA_CONTROL_VOICE_COMMAND =
    1u;
  static constexpr uint16_t MEDIA_CONTROL_MUTE =
    2u;
  static constexpr uint16_t MEDIA_CONTROL_PREV_TRACK_ANSWER =
    3u;
  static constexpr uint16_t MEDIA_CONTROL_NEXT_TRACK_HANG_UP =
    4u;
  static constexpr uint16_t MEDIA_CONTROL_VOL_UP =
    5u;
  static constexpr uint16_t MEDIA_CONTROL_VOL_DOWN =
    6u;
  static constexpr uint16_t SHIFT_PARK =
    0u;
  static constexpr uint16_t SHIFT_REVERSE =
    1u;
  static constexpr uint16_t SHIFT_NEUTRAL =
    2u;
  static constexpr uint16_t SHIFT_HIGH =
    3u;
  static constexpr uint16_t SHIFT_FORWARD =
    3u;
  static constexpr uint16_t SHIFT_LOW =
    4u;
  static constexpr uint16_t SHIFT_BETWEEN_GEARS =
    5u;
  static constexpr uint16_t SHIFT_ERROR =
    6u;
  static constexpr uint16_t SHIFT_NONE =
    7u;
  static constexpr uint16_t TURN_RIGHT =
    0u;
  static constexpr uint16_t TURN_NONE =
    1u;
  static constexpr uint16_t TURN_LEFT =
    2u;
  static constexpr uint16_t TURN_HAZARDS =
    3u;
  static constexpr uint16_t DOOR_NEUTRAL =
    0u;
  static constexpr uint16_t DOOR_OPEN =
    1u;
  static constexpr uint16_t DOOR_CLOSE =
    2u;
  static constexpr uint16_t WIPERS_OFF =
    0u;
  static constexpr uint16_t WIPERS_INT_1 =
    1u;
  static constexpr uint16_t WIPERS_INT_2 =
    2u;
  static constexpr uint16_t WIPERS_INT_3 =
    3u;
  static constexpr uint16_t WIPERS_INT_4 =
    4u;
  static constexpr uint16_t WIPERS_INT_5 =
    5u;
  static constexpr uint16_t WIPERS_INT_6 =
    6u;
  static constexpr uint16_t WIPERS_MEDIUM =
    7u;
  static constexpr uint16_t WIPERS_HIGH =
    8u;

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::SystemRptInt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::SystemRptInt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemRptInt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::SystemRptInt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__SystemRptInt
    std::shared_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__SystemRptInt
    std::shared_ptr<pacmod_msgs::msg::SystemRptInt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SystemRptInt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->enabled != other.enabled) {
      return false;
    }
    if (this->override_active != other.override_active) {
      return false;
    }
    if (this->command_output_fault != other.command_output_fault) {
      return false;
    }
    if (this->input_output_fault != other.input_output_fault) {
      return false;
    }
    if (this->output_reported_fault != other.output_reported_fault) {
      return false;
    }
    if (this->pacmod_fault != other.pacmod_fault) {
      return false;
    }
    if (this->vehicle_fault != other.vehicle_fault) {
      return false;
    }
    if (this->manual_input != other.manual_input) {
      return false;
    }
    if (this->command != other.command) {
      return false;
    }
    if (this->output != other.output) {
      return false;
    }
    return true;
  }
  bool operator!=(const SystemRptInt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SystemRptInt_

// alias to use template instance with default allocator
using SystemRptInt =
  pacmod_msgs::msg::SystemRptInt_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::CRUISE_CONTROL_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::CRUISE_CONTROL_CNCL;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::CRUISE_CONTROL_ACC_FURTHER;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::CRUISE_CONTROL_ACC_CLOSER;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::CRUISE_CONTROL_SET_DEC;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::CRUISE_CONTROL_RES_INC;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DASH_CONTROL_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DASH_CONTROL_OK;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DASH_CONTROL_LEFT;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DASH_CONTROL_RIGHT;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DASH_CONTROL_UP;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DASH_CONTROL_DOWN;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::HEADLIGHTS_OFF;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::HEADLIGHTS_PARKING_ONLY;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::HEADLIGHTS_MANUAL_LOW;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::HEADLIGHTS_MANUAL_HIGH;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::HEADLIGHTS_AUTO_LOW;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::HEADLIGHTS_AUTO_HIGH;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::MEDIA_CONTROL_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::MEDIA_CONTROL_VOICE_COMMAND;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::MEDIA_CONTROL_MUTE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::MEDIA_CONTROL_PREV_TRACK_ANSWER;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::MEDIA_CONTROL_NEXT_TRACK_HANG_UP;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::MEDIA_CONTROL_VOL_UP;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::MEDIA_CONTROL_VOL_DOWN;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_PARK;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_REVERSE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_NEUTRAL;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_HIGH;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_FORWARD;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_LOW;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_BETWEEN_GEARS;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_ERROR;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::SHIFT_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::TURN_RIGHT;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::TURN_NONE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::TURN_LEFT;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::TURN_HAZARDS;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DOOR_NEUTRAL;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DOOR_OPEN;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::DOOR_CLOSE;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_OFF;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_INT_1;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_INT_2;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_INT_3;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_INT_4;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_INT_5;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_INT_6;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_MEDIUM;
template<typename ContainerAllocator>
constexpr uint16_t SystemRptInt_<ContainerAllocator>::WIPERS_HIGH;

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__SYSTEM_RPT_INT__STRUCT_HPP_
