// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/VehicleDynamicsRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__VEHICLE_DYNAMICS_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__VEHICLE_DYNAMICS_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__VehicleDynamicsRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__VehicleDynamicsRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VehicleDynamicsRpt_
{
  using Type = VehicleDynamicsRpt_<ContainerAllocator>;

  explicit VehicleDynamicsRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->brake_torque = 0.0;
      this->g_forces = 0;
    }
  }

  explicit VehicleDynamicsRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->brake_torque = 0.0;
      this->g_forces = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _brake_torque_type =
    double;
  _brake_torque_type brake_torque;
  using _g_forces_type =
    uint8_t;
  _g_forces_type g_forces;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__brake_torque(
    const double & _arg)
  {
    this->brake_torque = _arg;
    return *this;
  }
  Type & set__g_forces(
    const uint8_t & _arg)
  {
    this->g_forces = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__VehicleDynamicsRpt
    std::shared_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__VehicleDynamicsRpt
    std::shared_ptr<pacmod_msgs::msg::VehicleDynamicsRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VehicleDynamicsRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->brake_torque != other.brake_torque) {
      return false;
    }
    if (this->g_forces != other.g_forces) {
      return false;
    }
    return true;
  }
  bool operator!=(const VehicleDynamicsRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VehicleDynamicsRpt_

// alias to use template instance with default allocator
using VehicleDynamicsRpt =
  pacmod_msgs::msg::VehicleDynamicsRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__VEHICLE_DYNAMICS_RPT__STRUCT_HPP_
