// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/VinRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__VIN_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__VIN_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__VinRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__VinRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VinRpt_
{
  using Type = VinRpt_<ContainerAllocator>;

  explicit VinRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mfg_code = "";
      this->mfg = "";
      this->model_year_code = "";
      this->model_year = 0ul;
      this->serial = 0ul;
    }
  }

  explicit VinRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    mfg_code(_alloc),
    mfg(_alloc),
    model_year_code(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mfg_code = "";
      this->mfg = "";
      this->model_year_code = "";
      this->model_year = 0ul;
      this->serial = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _mfg_code_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _mfg_code_type mfg_code;
  using _mfg_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _mfg_type mfg;
  using _model_year_code_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _model_year_code_type model_year_code;
  using _model_year_type =
    uint32_t;
  _model_year_type model_year;
  using _serial_type =
    uint32_t;
  _serial_type serial;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__mfg_code(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->mfg_code = _arg;
    return *this;
  }
  Type & set__mfg(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->mfg = _arg;
    return *this;
  }
  Type & set__model_year_code(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->model_year_code = _arg;
    return *this;
  }
  Type & set__model_year(
    const uint32_t & _arg)
  {
    this->model_year = _arg;
    return *this;
  }
  Type & set__serial(
    const uint32_t & _arg)
  {
    this->serial = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::VinRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::VinRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::VinRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::VinRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__VinRpt
    std::shared_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__VinRpt
    std::shared_ptr<pacmod_msgs::msg::VinRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VinRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->mfg_code != other.mfg_code) {
      return false;
    }
    if (this->mfg != other.mfg) {
      return false;
    }
    if (this->model_year_code != other.model_year_code) {
      return false;
    }
    if (this->model_year != other.model_year) {
      return false;
    }
    if (this->serial != other.serial) {
      return false;
    }
    return true;
  }
  bool operator!=(const VinRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VinRpt_

// alias to use template instance with default allocator
using VinRpt =
  pacmod_msgs::msg::VinRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__VIN_RPT__STRUCT_HPP_
