// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from pacmod_msgs:msg/WheelSpeedRpt.idl
// generated code does not contain a copyright notice

#ifndef PACMOD_MSGS__MSG__DETAIL__WHEEL_SPEED_RPT__STRUCT_HPP_
#define PACMOD_MSGS__MSG__DETAIL__WHEEL_SPEED_RPT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__pacmod_msgs__msg__WheelSpeedRpt __attribute__((deprecated))
#else
# define DEPRECATED__pacmod_msgs__msg__WheelSpeedRpt __declspec(deprecated)
#endif

namespace pacmod_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct WheelSpeedRpt_
{
  using Type = WheelSpeedRpt_<ContainerAllocator>;

  explicit WheelSpeedRpt_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_left_wheel_speed = 0.0;
      this->front_right_wheel_speed = 0.0;
      this->rear_left_wheel_speed = 0.0;
      this->rear_right_wheel_speed = 0.0;
    }
  }

  explicit WheelSpeedRpt_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_left_wheel_speed = 0.0;
      this->front_right_wheel_speed = 0.0;
      this->rear_left_wheel_speed = 0.0;
      this->rear_right_wheel_speed = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _front_left_wheel_speed_type =
    double;
  _front_left_wheel_speed_type front_left_wheel_speed;
  using _front_right_wheel_speed_type =
    double;
  _front_right_wheel_speed_type front_right_wheel_speed;
  using _rear_left_wheel_speed_type =
    double;
  _rear_left_wheel_speed_type rear_left_wheel_speed;
  using _rear_right_wheel_speed_type =
    double;
  _rear_right_wheel_speed_type rear_right_wheel_speed;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__front_left_wheel_speed(
    const double & _arg)
  {
    this->front_left_wheel_speed = _arg;
    return *this;
  }
  Type & set__front_right_wheel_speed(
    const double & _arg)
  {
    this->front_right_wheel_speed = _arg;
    return *this;
  }
  Type & set__rear_left_wheel_speed(
    const double & _arg)
  {
    this->rear_left_wheel_speed = _arg;
    return *this;
  }
  Type & set__rear_right_wheel_speed(
    const double & _arg)
  {
    this->rear_right_wheel_speed = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator> *;
  using ConstRawPtr =
    const pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__pacmod_msgs__msg__WheelSpeedRpt
    std::shared_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__pacmod_msgs__msg__WheelSpeedRpt
    std::shared_ptr<pacmod_msgs::msg::WheelSpeedRpt_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WheelSpeedRpt_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->front_left_wheel_speed != other.front_left_wheel_speed) {
      return false;
    }
    if (this->front_right_wheel_speed != other.front_right_wheel_speed) {
      return false;
    }
    if (this->rear_left_wheel_speed != other.rear_left_wheel_speed) {
      return false;
    }
    if (this->rear_right_wheel_speed != other.rear_right_wheel_speed) {
      return false;
    }
    return true;
  }
  bool operator!=(const WheelSpeedRpt_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WheelSpeedRpt_

// alias to use template instance with default allocator
using WheelSpeedRpt =
  pacmod_msgs::msg::WheelSpeedRpt_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace pacmod_msgs

#endif  // PACMOD_MSGS__MSG__DETAIL__WHEEL_SPEED_RPT__STRUCT_HPP_
